#ifndef _BIAS_DEFINITIONS_HH__
#define _BIAS_DEFINITIONS_HH__

/** Define common macros used in BIAS. This header file is included by bias_config.h */

/* use NL instead of endl. endl flushes the stream which is bad for file output */
#define NL "\r\n"

#define PRINT_FLOATING_POINT(number, leading, precision) setw(leading+precision+1) << setiosflags(ios::fixed) << \
  setprecision(precision) << (double) number

#define LOCALE_C_ON   string __CurrLocale__ = setlocale(LC_NUMERIC, NULL);\
  setlocale(LC_NUMERIC, "C");
  /* cout <<"Found Locale: "<<__CurrLocale__<<" setting to C temporarily"<<endl;*/

#define LOCALE_C_OFF setlocale(LC_NUMERIC,__CurrLocale__.c_str());
/*cout <<"Resetting Locale to: "<<__CurrLocale__<<endl;*/

#ifdef WIN32
#  define BIAS_ISNAN(x) isnan(x)
#  define BIAS_ISINF(x) isinf(x)
#else
#  define BIAS_ISNAN(x) std::isnan(x)
#  define BIAS_ISINF(x) std::isinf(x)
#endif


#endif /* BIAS_DEFINITIONS_HH_ */
