/*
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @example ExampleFileNames.cpp
   @relates FileHandling
   @brief Example for how to split a full path into its components directory, base of filename and extension of the filename.
   @ingroup g_examples
   @author woetzel
   \todo Windows may need some more work regarding the drive, in particular for network drives \\machine\share
*/

#include <iostream>
#include "Base/Common/FileHandling.hh"

using namespace std;
using namespace BIAS;


int main(int argc,char** argv){
  cout<<"current work directory "<<FileHandling::GetCwd()<<endl;

  string full("/this/is/a/directory/ThisIsABase.ext");
  string dir, base, ext;

  // command line arg given?
  if (argc>1) full=argv[1];

  cout<<"Splitting  "<<full<<" into: "<<endl;

  // run the function:
  FileHandling::SplitName(full, dir, base, ext);

  cout<<"\tdir  '"<<dir <<"'"<<endl
    <<"\tbase '"<<base<<"'"<<endl
    <<"\text  '"<<ext <<"'"<<endl;


  return 0;
}

