/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
   @example ExampleTypeSizes.cpp
   @brief Example sizes if types
   @ingroup g_examples
   @author MIP   
*/

#include <iostream>
#include <vector>
using namespace std;

#define OUTSIZE(t) cout<<"sizeof( "<<#t<<" ) = \t"<<sizeof(t)<<" byte(s)"<<endl;

int main(int argc, char *argv[])
{
  OUTSIZE(char);
  OUTSIZE(unsigned char);
  OUTSIZE(short int);
  OUTSIZE(unsigned short int);
  OUTSIZE(int);
  OUTSIZE(bool);
  OUTSIZE(unsigned int);
  OUTSIZE(unsigned long);
  OUTSIZE(long);
  OUTSIZE(long long int);
  OUTSIZE(unsigned long long int);
  OUTSIZE(float);
  OUTSIZE(double);
  OUTSIZE(long double);
  OUTSIZE(std::vector<int>::size_type);
  OUTSIZE(void*)
  return 0;
}

