/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
Multimediale Systeme der Informationsverarbeitung
Institut fuer Informatik
Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @example ExampleImageAttributes.cpp
   @relates ImageAttributes
   @brief Access Image attrobute susing ImageMagick, e.g. timestamp, focal length, shutter times automatically written to Jpeg header by digital cameras.  
   @ingroup g_examples
   @author woetzel
*/

#include <iostream>
#include <string>

#include <Base/Image/ImageAttributes.hh>

#ifndef BIAS_HAVE_IMAGEMAGICKLIB
#  error BIAS_HAVE_IMAGEMAGICKLIB not defined. Recompile BIAS with ImageMagick
#endif


using namespace std;
using namespace BIAS;


void usage(int argc, char** argv) {
    cerr<<"started ";
    if (argc>0) cerr<<argv[0]<<endl;
    cerr<<"usage: "<<endl
        <<argv[0]<<" <image-filename.jpg>"<<endl;
}


int main(int argc, char** argv)
{ 
  if (argc!=2) {
    usage(argc, argv);
    return 0;
  };
  
  string filename("");
  BIASASSERT(argc>1);
  filename=argv[1];
  
  ImageAttributes attr;
  attr.InitExifTags();
  attr.Read(filename);
  attr.Print(cout);
  
}
