/* This file is part of the BIAS library (Basic ImageAlgorithmS).
   
   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
#ifndef __BinomialCoefficient_hh__
#define __BinomialCoefficient_hh__

#include <BIAS_DeclSpec.hh>

namespace BIAS {

  /** @class BinomialCoefficient
      @brief Efficient  computation of the binomial coefficient
      @author woelk 01/2010 (c) www.vision-n.de */
  class BIASMathBase_EXPORT BinomialCoefficient 
  {
  public:
    /** Computation of the binomial coefficient "n over k" 
        The function throws an exception when overflow occurs. */
    static long long unsigned Compute(const unsigned n, const unsigned k);
  }; // class


} // namespace

#endif // __BinomialCoefficient_hh__
