#include <Base/Math/Random.hh>

using namespace BIAS;
using namespace std;

bool verbose = false;

int main(int argc, char *argv[])
{
  Random MyRandom;
  const unsigned num_vals = 10000000;
  unsigned min_val = 10, max_val = 200;
  vector<unsigned> hist(max_val-min_val+1, 0);
  for (unsigned i=0; i<num_vals; i++){
    int val = MyRandom.GetUniformDistributedInt(min_val, max_val);
    BIASASSERT(val>=(int)min_val && val<=(int)max_val);
    hist[val-min_val]++;
  }

  double mean_hist_entry = (double)num_vals / (double)hist.size();
  double max_acceptable_hist_eps = max(5.0, mean_hist_entry*0.1);
  for (unsigned i=0; i<hist.size(); i++){
    double hist_eps = fabs((double)hist[i] - mean_hist_entry);
    if (hist_eps>max_acceptable_hist_eps){
      for (unsigned t=0; t<hist.size(); t++){
        if (verbose){
          cout << t+min_val << "\t"<<hist[t] << endl;
        }
        cerr << "hist["<<t+min_val<<"]: "<<hist[t]
             <<"  (eps "<< fabs((double)hist[t] - mean_hist_entry)<<")\n";
      }
      cerr << "#mean hist_entry: "<<mean_hist_entry<<endl;
      BIASABORT;
    }
  }

  if (verbose){
    for (unsigned t=0; t<hist.size(); t++){
      cout << t+min_val << "\t"<<hist[t] << endl;
      //  cout << "hist["<<t+min_val<<"]: "<<hist[t]
      //     <<"  (eps "<< fabs((double)hist[t] - mean_hist_entry)<<")\n";
    }
    cout << "#mean hist_entry: "<<mean_hist_entry<<endl;
  }
  return 0;
}
