# - Try to find Aria
# Once done this will define
#  
#  ARIA_FOUND        - system has Aria
#  ARIA_INCLUDE_DIRS - the include directory
#  ARIA_LIBRARIES    - Link these to use Aria
#   

FIND_PATH( ARIA_INCLUDE_DIR
 Aria.h
PATHS
 /usr/include
 /usr/include/Aria
 /usr/local/Aria/include
 /opt/net64/gcc48/Aria/include/
)

FIND_PATH( ARIA_NETWORKING_INCLUDE_DIR
 ArNetworking.h
PATHS
 /usr/include
 /usr/include/Aria
 /usr/local/Aria/ArNetworking/include
 /opt/net64/gcc48/Aria/ArNetworking/include/
)

FIND_PATH( ARIA_POWERCUBE_INCLUDE_DIR
 ArPowerCubeArm.h
PATHS
 /usr/include
 /usr/include/Aria
 /usr/local/Aria/ArPowerCube/include
 /opt/net64/gcc48/Aria/ArPowerCube/include/
)


FIND_LIBRARY( ARIA_LIBRARY
  Aria
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/Aria/lib
  /opt/net64/gcc48/Aria/lib
)

FIND_LIBRARY( ARIA_NETWORKING_LIBRARY
  ArNetworking
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/Aria/lib
  /opt/net64/gcc48/Aria/lib
)

FIND_LIBRARY( ARIA_POWERCUBE_LIBRARY
  ArPowerCubeArm
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/Aria/lib
  /opt/net64/gcc48/Aria/lib
)


SET( ARIA_FOUND FALSE )

IF( ARIA_INCLUDE_DIR AND ARIA_NETWORKING_LIBRARY AND ARIA_LIBRARY )
  SET( ARIA_FOUND TRUE )
ENDIF()

IF( ARIA_FOUND )
  SET( ARIA_LIBRARIES 
    ${ARIA_LIBRARY}
    ${ARIA_NETWORKING_LIBRARY}
    ${ARIA_POWERCUBE_LIBRARY}
  )
  SET( ARIA_INCLUDE_DIRS
    ${ARIA_INCLUDE_DIR}
    ${ARIA_NETWORKING_INCLUDE_DIR}
    ${ARIA_POWERCUBE_INCLUDE_DIR}
  )
ENDIF()

MARK_AS_ADVANCED(
    ARIA_FOUND
    ARIA_LIBRARY
    ARIA_NETWORKING_LIBRARY
    ARIA_POWERCUBE_LIBRARY
    ARIA_INCLUDE_DIR
    ARIA_NETWORKING_INCLUDE_DIR
    ARIA_POWERCUBE_INCLUDE_DIR
)
