# Try to find Pan Tilt source code of Directed Perception
#
# Once run this will define: 
# 
# DP_PTU_FOUND = system has DP source
#
# DP_PTU_INCLUDE_DIR      = where to find headers
# DP_PTU_SOURCE_DIR      = where to find source  
#
# Ingo Schiller
#
# www.mip.informatik.uni-kiel.de
# --------------------------------

FIND_PATH(DP_PTU_INCLUDE_DIR ptu.h
   "${BIAS_SOURCE_DIR}/PanTilt/include")
   
FIND_PATH(DP_PTU_CODE_DIR ptu.c
  "${BIAS_SOURCE_DIR}/PanTilt/code")
   
IF(NOT DP_PTU_INCLUDE_DIR OR NOT DP_PTU_CODE_DIR)
  MESSAGE("-- Directed Perception include or source dir NOT found, put them in BIAS/PanTilt/code and BIAS/PanTilt/include")
  SET(DP_PTU_FOUND 0)
  SET(BIAS_HAVE_PANTILT_DP 0 CACHE INTERNAL " " FORCE)
ELSE(NOT DP_PTU_INCLUDE_DIR OR NOT DP_PTU_CODE_DIR)
  #MESSAGE("-- Found Directed Perception code and includes.")
  SET(DP_PTU_FOUND 1) 
  SET(BIAS_HAVE_PANTILT_DP 1 CACHE INTERNAL " " FORCE)
ENDIF(NOT DP_PTU_INCLUDE_DIR OR NOT DP_PTU_CODE_DIR)

 