FIND_PATH( FREENECT2_INCLUDE_DIR
 libfreenect2/libfreenect2.hpp
PATHS
 /usr/include
 /usr/local/include
 $ENV{EXTERN_LIBS_DIR}/freenect2/include
 /opt/net64/gcc48/freenect2/include
)

FIND_PATH( FREENECT2_TURBOJPEG_INCLUDE_DIR
 turbojpeg.h
PATHS
 /usr/include
 /usr/local/include
 $ENV{EXTERN_LIBS_DIR}/freenect2/include
)

FIND_LIBRARY( FREENECT2_LIBRARY
  freenect2
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/lib/
  /usr/local/lib64/
  $ENV{EXTERN_LIBS_DIR}/freenect2/lib
 /opt/net64/gcc48/freenect2/lib
)

FIND_LIBRARY( FREENECT2_TURBOJPEG_LIBRARY
 turbojpeg libturbojpeg
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/lib/
  /usr/local/lib64/
 /usr/lib/x86_64-linux-gnu
 $ENV{EXTERN_LIBS_DIR}/freenect2/lib
)

IF(WIN32)
FIND_LIBRARY( FREENECT2_LIBRARYD
  freenect2d
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/lib/
  /usr/local/lib64/
  $ENV{EXTERN_LIBS_DIR}/freenect2/lib
)

FIND_FILE( FREENECT2_RUNTIME
  freenect2.dll
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/lib/
  /usr/local/lib64/
  $ENV{EXTERN_LIBS_DIR}/freenect2/bin
)
ENDIF(WIN32)

SET( FREENECT2_FOUND FALSE )
SET( FREENECT2_TURBOJPEG_FOUND FALSE )
IF( FREENECT2_INCLUDE_DIR AND FREENECT2_LIBRARY )
  SET( FREENECT2_FOUND TRUE )
ENDIF()
SET( FREENECT2_TURBOJPEG_FOUND FALSE )
IF( FREENECT2_TURBOJPEG_INCLUDE_DIR AND FREENECT2_TURBOJPEG_LIBRARY )
  SET( FREENECT2_TURBOJPEG_FOUND TRUE )
ENDIF()

IF (FREENECT2_FOUND)
  IF ( FREENECT2_TURBOJPEG_FOUND )
    SET( FREENECT2_INCLUDE_DIRS ${FREENECT2_INCLUDE_DIR} ${FREENECT2_TURBOJPEG_INCLUDE_DIR})
    IF (WIN32)
	  SET( FREENECT2_LIBRARIES
	    debug ${FREENECT2_LIBRARYD} optimized ${FREENECT2_LIBRARY}
	    )
	  SET( FREENECT2_JPEGTURBO_LIBRARIES
	    debug ${FREENECT2_TURBOJPEG_LIBRARY} optimized ${FREENECT2_TURBOJPEG_LIBRARY}
	    )
    ELSE ()
	  SET( FREENECT2_LIBRARIES ${FREENECT2_LIBRARY})
	  SET( FREENECT2_TURBOJPEG_LIBRARY ${FREENECT2_TURBOJPEG_LIBRARY})
    ENDIF()
  ELSE()
    SET( FREENECT2_INCLUDE_DIRS ${FREENECT2_INCLUDE_DIR})
    IF (WIN32)
	  SET( FREENECT2_LIBRARIES  debug ${FREENECT2_LIBRARYD} optimized ${FREENECT2_LIBRARY} )
    ELSE ()
	  SET( FREENECT2_LIBRARIES ${FREENECT2_LIBRARY})
    ENDIF()
  ENDIF()
ENDIF()
