# ----------------------------------------------------
# Search for GDAL - geospatial data abstraction lib
# see http://www.gdal.org
# ----------------------------------------------------
# kkoeser, 05/2014

FIND_PATH(GDAL_INCLUDE_DIR gdal/gdal.h
   /usr/include
   $ENV{GDAL_DIR}/include
 )
#MESSAGE("DBG GDAL_INCLUDE_DIR=${GDAL_INCLUDE_DIR}")  

FIND_LIBRARY(GDAL_LIBRARY
  NAMES gdal
  PATHS /usr/lib64 $ENV{GDAL_DIR}/lib
  )
#MESSAGE("DBG GDAL_LIBRARY=${GDAL_LIBRARY}")  

IF(GDAL_INCLUDE_DIR)
  IF (GDAL_LIBRARY)
    SET(GDAL_FOUND TRUE)
    GET_FILENAME_COMPONENT(GDAL_LINK_DIRECTORIES ${GDAL_LIBRARY} PATH)
  ELSE (GDAL_LIBRARY)
    MESSAGE("GDAL library, e.g. /usr/lib64/libgdal.so, not found. Set GDAL_DIR to find it.")
  ENDIF(GDAL_LIBRARY)
ELSE(GDAL_INCLUDE_DIR)
  MESSAGE("GDAL header gdal/gdal.h not found. Set GDAL_DIR to find it.")
ENDIF(GDAL_INCLUDE_DIR)


MARK_AS_ADVANCED(
GDAL_INCLUDE_DIR
GDAL_LIBRARY
GDAL_LINK_DIRECTORIES
)
