# 
# CMake Find Script for the Internet Copmmunications Engine (ICE) Library 
# Right now it only searches for the ZeroC version of ICE (see www.zeroc.com)
# 
# jordt 2010
#
# This file sets the following variables:
# ICE_FOUND
# ICE_INCLUDE_DIR 
# ICE_LIBRARIES
# ICE_LINK_DIRECTORIES
#

 FIND_PATH(ICE_INCLUDE_DIR Ice/Ice.h
   ${ICE_INCLUDE_DIR}/include
   ${ICE_HOME}/include
   ${ICE_DIR}
   ${ICE_HOME}
   $ENV{ICE_DIR}/include
   $ENV{ICE_HOME}/include
   $ENV{ICE_DIR}
   $ENV{ICE_HOME}
   $ENV{EXTERN_LIBS_DIR}
   $ENV{EXTERN_LIBS_DIR}/include
   /usr/include
   /usr/local/include
   $ENV{SOURCE_DIR}
   $ENV{SOURCE_DIR}/include
   $ENV{SOURCE_DIR}
   $ENV{SOURCE_DIR}/include
 )
#MESSAGE("DBG ICE_INCLUDE_DIR=${ICE_INCLUDE_DIR}")  


SET(ICE_POSSIBLE_LIBRARY_PATH
  ${ICE_DIR}/lib
  ${ICE_DIR}/lib64
  ${ICE_HOME}/lib
  ${ICE_HOME}/lib64
  ${ICE_DIR}
  ${ICE_HOME}  
  $ENV{ICE_DIR}/lib
  $ENV{ICE_DIR}/lib64
  $ENV{ICE_HOME}/lib
  $ENV{ICE_HOME}/lib64
  $ENV{EXTERN_LIBS_DIR}/Ice
  $ENV{EXTERN_LIBS_DIR}/Ice/lib
  $ENV{EXTERN_LIBS_DIR}/Ice/lib64
  /usr/lib
  /usr/lib64
  /usr/local/lib
  /usr/local/lib64
  $ENV{SOURCE_DIR}/Ice
  $ENV{SOURCE_DIR}/Ice/lib
  $ENV{SOURCE_DIR}/Ice/lib64
  $ENV{SOURCE_DIR}/Ice
  $ENV{SOURCE_DIR}/Ice/lib
  $ENV{SOURCE_DIR}/Ice/lib64
)

SET(ICE_POSSIBLE_BINARY_PATH
  ${ICE_DIR}/bin
  ${ICE_HOME}/bin
  ${ICE_DIR}
  ${ICE_HOME}  
  $ENV{ICE_DIR}/bin
  $ENV{ICE_HOME}/bin
  $ENV{EXTERN_LIBS_DIR}/Ice
  $ENV{EXTERN_LIBS_DIR}/Ice/bin
  /usr/bin
  /usr/local/bin
  $ENV{SOURCE_DIR}/Ice
  $ENV{SOURCE_DIR}/Ice/bin
  $ENV{SOURCE_DIR}/Ice
  $ENV{SOURCE_DIR}/Ice/bin
)



  
FIND_LIBRARY(ICE_LIBRARIES
  NAMES Ice libIce
  PATHS 
  ${ICE_POSSIBLE_LIBRARY_PATH}
  )

FIND_LIBRARY(ICE_UTILS_LIBRARIES
  NAMES IceUtil libIceUtil
  PATHS 
  ${ICE_POSSIBLE_LIBRARY_PATH}
  )


#MESSAGE("DBG ICE_LIBRARIES=${ICE_LIBRARIES}")

FIND_PROGRAM(ICE_COMPILER
  NAMES slice2cpp
  PATHS 
  ${ICE_POSSIBLE_COMPILER_PATH}
  )
#MESSAGE("DBG ICE_COMPILER=${ICE_COMPILER}")

FIND_PROGRAM(SED_BINARY
  NAMES sed
  PATHS 
  /usr/bin
  )

IF(ICE_LIBRARIES)
  IF (ICE_COMPILER)
    IF (ICE_INCLUDE_DIR)
    
      # OK, found all we need
      SET(ICE_FOUND TRUE)
      GET_FILENAME_COMPONENT(ICE_LINK_DIRECTORIES ${ICE_LIBRARIES} PATH)
      
    
    ELSE (ICE_INCLUDE_DIR)
      MESSAGE("ICE include dir not found. Set ICE_DIR to find it.")
    ENDIF(ICE_INCLUDE_DIR)
  ELSE(ICE_COMPILER)
    MESSAGE("Could not find ICE compiler slice2cpp. Check if C++ support for ICE is installed")
  ENDIF(ICE_COMPILER)    
ELSE(ICE_LIBRARIES)
  MESSAGE("ICE lib not found. Set e.g. ICE_HOME to find it.")
ENDIF(ICE_LIBRARIES)

MACRO(COMPILE_SLICE SLICE_FILE)
  EXECUTE_PROCESS( COMMAND ${ICE_COMPILER} ${SLICE_FILE} )
ENDMACRO(COMPILE_SLICE SLICE_FILE)

SET(ICE_LIBRARIES ${ICE_LIBRARIES} ${ICE_UTILS_LIBRARIES})


MARK_AS_ADVANCED(
  ICE_INCLUDE_DIR
  ICE_LIBRARIES
  ICE_UTILS_LIBRARIES
  ICE_LINK_DIRECTORIES
)


#Use this function to compile slice files to cpp
FUNCTION(RUN_SLICE2CPP arg)
   #Generate random string
   SET(ICE_COMPILE_STRING "${ICE_COMPILER} ${arg}.ice")
   
   execute_process(COMMAND ${ICE_COMPILER} ${arg}.ice
                   WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})  
             
   
   FILE(READ ${CMAKE_CURRENT_SOURCE_DIR}/${arg}.cpp READ_GENERATED_ICE_CPP)
   STRING(REPLACE "<${arg}.h>" "\"${arg}.h\"" WRITE_GENERATED_ICE_CPP "${READ_GENERATED_ICE_CPP}")
   FILE(WRITE ${CMAKE_CURRENT_SOURCE_DIR}/${arg}.cpp "${WRITE_GENERATED_ICE_CPP}")
                   
    #   sed -i 's/<ME3DCom.h>/\"ME3DCom.h\"/g' ME3DCom.cpp
                
                   
                   
   #SET(SED_STRING "-i 's/<${arg}.h>/\\\"${arg}.h\\\"/g' ${CMAKE_CURRENT_SOURCE_DIR}/${arg}.cpp")
   #execute_process(COMMAND ${SED_BINARY} -i 's/<${arg}.h>/\\\"${arg}.h\\\"/g' ${CMAKE_CURRENT_SOURCE_DIR}/${arg}.cpp
   #                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
   #                OUTPUT_VARIABLE OUTPUT_STRING
   #                RESULT_VARIABLE RESULT_STRING
   #                ERROR_VARIABLE ERROR_STRING)                   
                   
   #MESSAGE("DBG SED_STRING=${SED_STRING}")
   #MESSAGE("DBG OUTPUT_STRING=${OUTPUT_STRING}")
   #MESSAGE("DBG RESULT_STRING=${RESULT_STRING}")
   #MESSAGE("DBG ERROR_STRING=${ERROR_STRING}")
   #MESSAGE("DBG CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}")
   #STRING(RANDOM randstring)
   #Rename the class in the precompiler step
   #ADD_DEFINITIONS(-D${arg}=${arg}${randstring})
   #Rename the output file
   #SET_TARGET_PROPERTIES(${arg} PROPERTIES PREFIX "libE3DP_${randstring}_")
   #Find old files with different, randomly generated name
   #FILE(GLOB testVar ${LIBRARY_OUTPUT_PATH}/libE3DP_*_${arg}*.so)
   #delete all old files so only one file is present at a time
   #FOREACH(loopVar ${testVar})
   #  EXECUTE_PROCESS(COMMAND rm ${loopVar})
   #ENDFOREACH(loopVar)
ENDFUNCTION()