# Search for nlopt package
# NLOPT_FOUND
# NLOPT_INCLUDE_DIR
# NLOPT_LIBRARIES

IF(WIN32)

  # TODO Implement for WIN32!

  SET(NLOPT_FOUND FALSE)
  MSG_FATAL("nlopt package is not yet available for WIN32!")

ELSE(WIN32)	    

  execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                  OUTPUT_VARIABLE GCC_VERSION)
  IF(GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
    # MESSAGE("Version >= 4.7")c
    FIND_PATH(NLOPT_INCLUDE_DIR "nlopt.hpp" 
              "/opt/net64/gcc47/nlopt/include/"
              "/opt/nlopt/include")
#    find_library(NLOPT_LIB nlopt_cxx #Version Anne
find_library(NLOPT_LIB nlopt
                 "/opt/net64/gcc47/nlopt/lib64"
                 "/opt/nlopt/lib64/")
  ELSE(GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
    MESSAGE("Version < 4.7")
    FIND_PATH(NLOPT_INCLUDE_DIR "nlopt.hpp" 
              "/opt/net64/gcc44/nlopt-2.2.1/include/"
              "/usr/local/include")
    find_library(NLOPT_LIB nlopt_cxx
                 "/opt/net64/gcc44/nlopt-2.2.1/lib"
                 "/usr/local/lib/" 
                 "/usr/local/lib64/")
 ENDIF(GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
  
  IF(NLOPT_INCLUDE_DIR)
    #MESSAGE(${NLOPT_INCLUDE_DIR})
    IF(NLOPT_LIB)
      SET(NLOPT_LIBRARIES ${NLOPT_LIB})
      SET(NLOPT_FOUND TRUE)

    ELSE(NLOPT_LIB)

      SET(NLOPT_FOUND FALSE)

    ENDIF(NLOPT_LIB)

  ELSE(NLOPT_INCLUDE_DIR)

    SET(NLOPT_FOUND FALSE)

  ENDIF(NLOPT_INCLUDE_DIR)

ENDIF(WIN32)
 
 

 
