# - Try to find openni/nite camera driver
# Once done this will define
#  
#   

FIND_PATH( OPENNI_INCLUDE_DIR
 XnOpenNI.h
PATHS
 /usr/include/ni
 /usr/local/include/ni
 $ENV{OPEN_NI_INSTALL_PATH}/Include
)

FIND_LIBRARY( OPENNI_LIBRARY
  OpenNI
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/lib/
  /usr/local/lib64/
 $ENV{OPEN_NI_INSTALL_PATH}/Lib
)

# Nite 64 not available for windows
IF (UNIX)

FIND_PATH( NITE_INCLUDE_DIR
 XnVNite.h
PATHS
 /usr/include/nite
 /usr/local/include/nite
 $ENV{OPEN_NI_INSTALL_PATH}/Include
)

FIND_LIBRARY( NITE_LIBRARY
  XnVNite
PATHS
  /usr/lib/
  /usr/lib64/
  /usr/local/lib/
  /usr/local/lib64/
  $ENV{OPEN_NI_INSTALL_PATH}/Lib
)
ENDIF(UNIX)

SET( OPENNI_FOUND FALSE )

IF( OPENNI_INCLUDE_DIR AND OPENNI_LIBRARY )
  SET( OPENNI_FOUND TRUE )
  IF(NOT NITE_LIBRARY)
    MESSAGE("WARNING: could not find OpenNI Nite library, enabling OpenNI support only.")
    SET( OPENNI_INCLUDE_DIRS ${OPENNI_INCLUDE_DIR})
    SET( OPENNI_LIBRARIES ${OPENNI_LIBRARY})
  ELSE(NOT NITE_LIBRARY)
    SET( OPENNI_INCLUDE_DIRS ${OPENNI_INCLUDE_DIR} ${NITE_INCLUDE_DIR})
    SET( OPENNI_LIBRARIES ${OPENNI_LIBRARY} ${NITE_LIBRARY})
  ENDIF(NOT NITE_LIBRARY)
ENDIF()


MARK_AS_ADVANCED(
  OPENNI_INCLUDE_DIR
  OPENNI_LIBRARY
  NITE_INCLUDE_DIR
  NITE_LIBRARY
  )