# Find PMDTec time of flight camera access include+library
# See www.PMDtec.de
#
# Birger Streckel

# Falko Kellner, 3/09

IF(USE_PMD_PMDTec)
  FIND_PATH(PMDTec_INCLUDE_DIR pmdsdk2.h
	"$ENV{EXTERN_LIBS_DIR}/PMDSDK2/include"
	"c:/Externlibs/PMDSDK2/include"
        /usr/include/pmdsdk2
        /usr/include
        /usr/local/include
        /usr/local/include/pmdsdk2
    )

  FIND_LIBRARY(PMDTec_LIBRARY 
    NAMES pmdaccess2
    PATHS
	"$ENV{EXTERN_LIBS_DIR}/PMDSDK2/bin"
	"c:/Externlibs/PMDSDK2/bin"
        /usr/lib64
        /usr/lib
	/usr/local/lib
        /usr/local/lib64
    DOC "PMDSDK2 library"
    )

  FIND_FILE(PMDTec_PLUGIN_SOURCE 
    NAMES camcube.W32.pap camcube.L64.pap camcube.L32.pap
    PATHS
      "$ENV{EXTERN_LIBS_DIR}/PMDSDK2/plugins"
      "c:/Externlibs/PMDSDK2/plugins"
      /usr/lib64
      /usr/lib
      /usr/local/lib
      /usr/local/lib64
    DOC "PMDSDK2 CamCube source plugin"
    )

  FIND_FILE(PMDTec_PLUGIN_PROCESSING 
    NAMES camcubeproc.W32.ppp camcubeproc.L64.ppp camcubeproc.L32.ppp
    PATHS
      "$ENV{EXTERN_LIBS_DIR}/PMDSDK2/plugins"
      "c:/Externlibs/PMDSDK2/plugins"
      /usr/lib64
      /usr/lib
      /usr/local/lib
      /usr/local/lib64
    DOC "PMDSDK2 CamCube processing plugin"
    )

ENDIF(USE_PMD_PMDTec)

IF(PMDTec_INCLUDE_DIR AND PMDTec_LIBRARY AND PMDTec_PLUGIN_SOURCE AND PMDTec_PLUGIN_PROCESSING)
  SET( PMDTec_FOUND TRUE )
  SET( PMDTec_LIBRARIES ${PMDTec_LIBRARY} )
ENDIF(PMDTec_INCLUDE_DIR AND PMDTec_LIBRARY AND PMDTec_PLUGIN_SOURCE AND PMDTec_PLUGIN_PROCESSING)


IF(USE_PMD_PMDZess)
  FIND_PATH(PMDZess_INCLUDE_DIR PMDDll.h
    ${PMDZESS_ROOT_DIR}
    $ENV{PMD_ROOT_DIR}
	$ENV{PMDZESS_ROOT_DIR}
    $ENV{PMD_DIR}
	$ENV{PMDZESS_DIR}
	"$ENV{EXTERN_LIBS_DIR}/PMDZess/SDK"
    )

  FIND_LIBRARY(PMDZess_LIBRARY 
    NAMES PMDDll
    PATHS
    ${PMDZESS_ROOT_DIR}
	$ENV{PMD_ROOT_DIR}
    $ENV{PMDZESS_ROOT_DIR}
    $ENV{PMDZESS_DIR}
    $ENV{PMD_DIR}	
    "$ENV{EXTERN_LIBS_DIR}/PMDZess/SDK"
	DOC "PMDZess library"
    )
ENDIF(USE_PMD_PMDZess)


IF(PMDZess_INCLUDE_DIR)
  IF(PMDZess_LIBRARY)
    SET( PMDZess_FOUND TRUE )
    SET( PMDZess_LIBRARIES ${PMDZess_LIBRARY} )
  ENDIF(PMDZess_LIBRARY)
ENDIF(PMDZess_INCLUDE_DIR)



