# Search for siftgpu package
# SIFTGPU_FOUND
# SIFTGPU_INCLUDE_DIR
# SIFTGPU_LIBRARIES

IF(WIN32)

  # TODO Implement for WIN32!

  SET(SIFTGPU_FOUND FALSE)
  MSG_FATAL("SiftGPU package is not yet available for WIN32!")

ELSE(WIN32)	    

  execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                  OUTPUT_VARIABLE GCC_VERSION)
  IF(GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
#    MESSAGE("Version >= 4.7")
    FIND_PATH(SiftGPU_INCLUDE_DIR "SiftGPU.h" 
              "$ENV{SiftGPU_DIR}/include/SiftGPU"
	      "/opt/net64/gcc47/SiftGPU/include/SiftGPU")
    #MESSAGE("include dir is ${SiftGPU_INCLUDE_DIR}")
    find_library(SiftGPU_LIB libsiftgpu.so
                 "/opt/net64/gcc47/SiftGPU/lib"
                 "$ENV{SiftGPU_DIR}/bin")
    #MESSAGE("lib is ${SiftGPU_LIB}")
  ELSE(GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
    MESSAGE("gcc Version < 4.7")
    FIND_PATH(SiftGPU_INCLUDE_DIR "SiftGPU.h" 
              "/opt/net64/gcc45/SiftGPU-noIL/include/SiftGPU"
              "$ENV{SiftGPU_DIR}/include/SiftGPU")
    find_library(SiftGPU_LIB libsiftgpu.so
                 "/opt/net64/gcc45/SiftGPU-noIL/lib"
                  "$ENV{SiftGPU_DIR}/lib")
  ENDIF(GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)


  IF(SiftGPU_INCLUDE_DIR)
    #MESSAGE(${SiftGPU_INCLUDE_DIR})
    IF(SiftGPU_LIB)

      SET(SiftGPU_LIBRARIES ${SiftGPU_LIB})
      SET(SiftGPU_FOUND TRUE)

    ELSE(SiftGPU_LIB)

      SET(SiftGPU_FOUND FALSE)

    ENDIF(SiftGPU_LIB)

  ELSE(SiftGPU_INCLUDE_DIR)

    SET(SiftGPU_FOUND FALSE)

  ENDIF(SiftGPU_INCLUDE_DIR)

ENDIF(WIN32)
 
 

 
# libil comes with the open suse games repository
