MACRO(FindTheseLibs )

  IF (WIN32)
    SET(LIBPOSTFIX ".dll")
    SET(LISTPOSTFIX "_REL")
    IF(CMAKE_GENERATOR MATCHES "Makefiles") 
      SET(LIBPREFIX "") 
    ELSE(CMAKE_GENERATOR MATCHES "Makefiles") 
      SET(LIBPREFIX "release/") 
    ENDIF(CMAKE_GENERATOR MATCHES "Makefiles") 
  ELSE(WIN32)
    IF(APPLE)
      SET(LISTPOSTFIX "")
      SET(LIBPOSTFIX ".dylib")
      SET(LIBPREFIX "Release/lib")
    ELSE(APPLE)
      SET(LIBPREFIX "lib") 
      SET(LISTPOSTFIX "")
      SET(LIBPOSTFIX ".so")
    ENDIF(APPLE)
  ENDIF (WIN32)

  SET(LIBS_FOUND "")
  
  FOREACH(_LIB_ ${ARGV})
    SET(LIBFILE "LIBFILE-NOTFOUND")
#MESSAGE("Searching for: ${LIBPREFIX}${_LIB_}${LIBPOSTFIX}")
#MESSAGE("In: ${BIAS_DIR}/lib")
    FIND_FILE(LIBFILE ${LIBPREFIX}${_LIB_}${LIBPOSTFIX}
      ${BIAS_DIR}/lib
      ${MIP_DIR}/lib
      ${VN_DIR}/lib
      )
    IF(LIBFILE)
#      MESSAGE("for ${_LIB_} take: ${LIBFILE}")
      LIST(APPEND LIBS_FOUND ${LIBFILE})
    ELSE(LIBFILE)
      MESSAGE("cannot find: ${_LIB_} for packaging. Please ensure existing release build.")
    ENDIF(LIBFILE)
  ENDFOREACH(_LIB_ ${LIBS})

ENDMACRO(FindTheseLibs )