# - Try to find TriMesh2 (http://gfx.cs.princeton.edu/proj/trimesh2/)
# Once done this will define
#  TRIMESH_FOUND - System has TriMesh2
#  TRIMESH_INCLUDE_DIRS - The TriMesh2 include directories
#  TRIMESH_LIBRARIES - The libraries needed to use TriMesh2
#  TRIMESH_DEFINITIONS - Compiler switched required for TriMesh2
#
# Author
#  Stefan Reinhold (sre@informatik.uni-kiel.de) August 2015

find_path(TRIMESH_ROOT include/TriMesh.h
  PATHS
    /opt/net64/llvm35/trimesh2
    /usr
    /usr/local
    ENV TRIMESH_ROOT
  )

find_path(TRIMESH_INCLUDE_DIR TriMesh.h
    HINTS
      ${TRIMESH_ROOT}/include
)

find_library(TRIMESH_LIBRARY NAMES trimesh
  HINTS
    ${TRIMESH_ROOT}/lib
)

set(TRIMESH_LIBRARIES ${TRIMESH_LIBRARY})
set(TRIMESH_INCLUDE_DIRS ${TRIMESH_INCLUDE_DIR})

include(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(TriMesh DEFAULT_MSG
  TRIMESH_LIBRARY TRIMESH_INCLUDE_DIR
)

add_library(TriMesh INTERFACE IMPORTED)
set_property(TARGET TriMesh PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${TRIMESH_INCLUDE_DIRS})
set_property(TARGET TriMesh PROPERTY INTERFACE_LINK_LIBRARIES ${TRIMESH_LIBRARIES})
message(STATUS "Found TriMesh")
mark_as_advanced(TRIMESH_INCLUDE_DIR TRIMESH_LIBRARIES TRIMESH_ROOT TRIMESH_LIBRARY)

set(TriMesh_FOUND true)
