SET(VIENNACL_DIR_DESCRIPTION "directory containing ViennaCLConfig.cmake.")
SET(VIENNACL_DIR_MESSAGE "ViennaCL not found. Set the VIENNACL_DIR cmake variable on environment variable to the ${CGAL_DIR_DESCRIPTION}")

SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

IF(NOT VIENNACL_DIR)
  IF(UNIX)
    STRING(REGEX MATCHALL "[^:]+" VIENNACL_DIR_SEARCH1 "$ENV{PATH}")
  ENDIF(UNIX)

  STRING(REGEX REPLACE "/;" ";" VIENNACL_DIR_SEACH2 "${VIENNACL_DIR_SEARCH1}")

  SET(VIENNACL_DIR_SEARCH "")

  FOREACH(dir ${VIENNACL_DIR_SEACH2})
    SET(VIENNACL_DIR_SEARCH ${VIENNACL_DIR_SEARCH} ${dir}/../lib/cmake/viennacl)
  ENDFOREACH()

  FIND_PATH(VIENNACL_DIR ViennaCLConfig.cmake
    $ENV{VIENNACL_DIR}
    ${VIENNACL_DIR_SEARCH}
    /usr/local/lib/cmake/viennacl
    /usr/local/lib64/cmake/viennacl
    /usr/lib/cmake/viennacl
    /usr/lib64/cmake/viennacl

    DOC "The ${VIENNACL_DIR_DESCRIPTION}"
  )
ENDIF(NOT VIENNACL_DIR)

IF(VIENNACL_DIR)
  IF(EXISTS "${VIENNACL_DIR}/ViennaCLConfig.cmake")
    INCLUDE("${VIENNACL_DIR}/ViennaCLConfig.cmake")
    add_library(ViennaCL INTERFACE IMPORTED)
    set_property(TARGET ViennaCL PROPERTY INTERFACE_LINK_LIBRARIES ${VIENNACL_LIBRARIES})
    set_property(TARGET ViennaCL PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${VIENNACL_INCLUDE_DIRS})
    SET(ViennaCL_FOUND true)
  ELSE()
    MESSAGE(STATUS ${VIENNACL_DIR_MESSAGE})
  ENDIF()
ENDIF()

