## Dart client configuration
## to submit BIAS build results to remote server
## ######################################################



IF(I_AM_AT_VISION_N)
  SET (DROP_SITE "intern.vision-n.de"
    CACHE STRING "Remote drop sites DNS name or IP address")
  
  SET (DROP_SITE_USER ""
    CACHE STRING "Username for remote access to drop site.")
  
  SET (DROP_SITE_PASSWORD ""
    CACHE STRING "Password for remote access to drop site.")
  
  SET (DROP_LOCATION "/CDash/submit.php?project=BIAS"
    CACHE STRING "Directory on remote drop site.")
  
  SET (DROP_METHOD "http"
    CACHE STRING "Method for dropping files. Can be ftp, scp or cp.")
  
  SET (NIGHTLY_START_TIME "02:05:00 GMT"
    CACHE STRING "agreed CVS snapshot timestamp for nightly builds")
  
  SET (TRIGGER_SITE "http://intern.vision-n.de"
    CACHE STRING "URL for drop notification.")
ELSE(I_AM_AT_VISION_N)

  SET (DROP_SITE "dash"
    CACHE STRING "Remote drop sites DNS name or IP address")
  
  SET (DROP_SITE_USER ""
    CACHE STRING "Username for remote access to drop site.")
  
  SET (DROP_SITE_PASSWORD ""
    CACHE STRING "Password for remote access to drop site.")
  
  SET (DROP_LOCATION "/CDash/submit.php?project=BIAS"
    CACHE STRING "Directory on remote drop site.")
  
  SET (DROP_METHOD "http"
    CACHE STRING "Method for dropping files. Can be ftp, scp or cp.")
  
  SET (NIGHTLY_START_TIME "02:05:00 GMT"
    CACHE STRING "agreed CVS snapshot timestamp for nightly builds")
  
  SET (TRIGGER_SITE "http://dash/CDash/submit.php?project=BIAS"
    CACHE STRING "URL for drop notification.")

  SET (CTEST_DROP_SITE_CDASH TRUE)
  
ENDIF(I_AM_AT_VISION_N)

# TODO SET(UPDATE_TYPE cvs)

## find tool for memory leak debugging, e.g. valgrind or purify 
IF (UNIX)
  FIND_PROGRAM(VALGRIND_COMMAND 
        NAMES valgrind Valgrind
        PATHS "/usr/bin" "/usr/local/bin"
        DOC "valgrind binary used to run Memory Check")
  # SET(VALGRIND_COMMAND "/usr/bin/valgrind" CACHE STRING "valgrind binary")
  IF (VALGRIND_COMMAND)
    SET(VALGRIND_COMMAND_OPTIONS 
        "-q --leak-check=full --show-reachable=yes --num-callers=100 --pointercheck=yes --workaround-gcc296-bugs=yes --suppressions=${BIAS_SOURCE_DIR}/Tests/config/linux/valgrind.supp"
        CACHE STRING "options for valgrind")
    MESSAGE(STATUS "Found valgrind: VALGRIND_COMMAND=${VALGRIND_COMMAND}")
    #MESSAGE(STATUS "Valgrind command options: VALGRIND_COMMAND_OPTIONS=${VALGRIND_COMMAND_OPTIONS}")
  ENDIF (VALGRIND_COMMAND)
ELSE (UNIX)
  IF (WIN32)
    ## DBG 
    FIND_PROGRAM(VALGRIND_COMMAND 
        NAMES purify purify.exe
        PATHS "C:/Program Files/Rational/Common" "$ENV{ProgramFiles}/Rational/Common"
        DOC "purify binary used to run Memory Check")
    # SET(PURIFY_COMMAND "C:/Program Files/Rational/Common/purify.exe" CACHE STRING "purify binary")
    IF (PURIFY_COMMAND)
      MESSAGE(STATUS "FOUND purify as: \n\tPURIFY_COMMAND=${PURIFY_COMMAND} \n\tPURIFY_COMMAND_OPTIONS=${PURIFY_COMMAND_OPTIONS}")
    ENDIF (PURIFY_COMMAND)
  ENDIF (WIN32)
ENDIF (UNIX)


MARK_AS_ADVANCED(
  DROP_SITE
  DROP_SITE_USER
  DROP_SITE_PASSWORD  
  DROP_LOCATION
  DROP_METHOD
  TRIGGER_SITE
  NIGHTLY_START_TIME
  VALGRIND_COMMAND
  VALGRIND_COMMAND_OPTIONS
)


## ######################################################
## Acts as the agreed Dart server?
## 
IF (UNIX)
  OPTION(BIAS_DASHBOARD_SERVER "Is this the agreed Dart server?" FALSE)
  MARK_AS_ADVANCED(BIAS_DASHBOARD_SERVER )
  IF( BIAS_DASHBOARD_SERVER )
    INCLUDE( ${BIAS_SOURCE_DIR}/DartConfigServer.cmake )
  ENDIF( BIAS_DASHBOARD_SERVER )
ENDIF (UNIX)
