/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "CornerDetectorBase.hh"
#include <Base/Common/W32Compat.hh>
#include <Base/Common/BIASpragma.hh>


using namespace BIAS;
using namespace std;

//////////////////////////////////////////////////////////////////////////
//                 implementation
//////////////////////////////////////////////////////////////////////////


template <class StorageType>
CornerDetectorBase<StorageType>::
CornerDetectorBase() 
{
  _MaxNum = 0;
}

template <class StorageType>
CornerDetectorBase<StorageType>::
~CornerDetectorBase()
{
}

template <class StorageType>
int CornerDetectorBase<StorageType>::
Detect(const Image<StorageType>& image, std::vector<HomgPoint2D>& p, 
       std::vector<QUAL>& quality)
{
  BIASERR("call this function from derived class");
  return -10;
}

//////////////////////////////////////////////////////////////////////////
//                 instantiation
//////////////////////////////////////////////////////////////////////////
namespace BIAS{
template class CornerDetectorBase<unsigned char>; 
template class CornerDetectorBase<float>; 

// fill in instances as required
#ifdef BUILD_IMAGE_INT
#endif
#ifdef BUILD_IMAGE_CHAR
template class CornerDetectorBase<char>; 
#endif
#ifdef BUILD_IMAGE_SHORT
#endif
#ifdef BUILD_IMAGE_USHORT
template class CornerDetectorBase<unsigned short>; 
#endif
#ifdef BUILD_IMAGE_UINT
#endif
#ifdef BUILD_IMAGE_DOUBLE
#endif
}
