/**
   @file TestBlobDetectDOM
   @brief Test the difference of means blob detector
   @ingroup g_tests
   @author jordt
   @date 11/2010
*/

#include <FeatureDetector/BlobDetectorDOM.hh>
#include <Base/ImageUtils/ImageDraw.hh>

using  namespace BIAS;
using namespace std;


/// Paint Circles and detect them
int main(int argc, char* argv[]){

  // Generate a checkerboard image
  Image<float> testImg;
  testImg.Init(1024,768,3);
  testImg.Clear();
  float white[] = {255.0,255.0,255.0};
  for (int xpos  = 100; xpos < 1000; xpos+= 200)
    for (int ypos  = 100; ypos < 700; ypos+= 200)
      ImageDraw<float>::RectangleCornersFill(testImg,xpos-15,ypos-15,xpos+15,ypos+15,white);

  // Detect blobs
    vector<HomgPoint2D> blobs;
  vector<float> qualvec;
  BlobDetectorDOM<float> bdd;
  bdd.SetThreshold(50.0);
  bdd.SetCabin(4,2);
  vector<BIASBlob> b;
  bdd.Detect(testImg,b);
  bdd.GetBlobsAsHomgPoint2D(blobs,qualvec);

  // Check if result is correct
  for (int xpos  = 100; xpos < 1000; xpos+= 200)
    for (int ypos  = 100; ypos < 700; ypos+= 200){
    bool foundBlob = false;
    for (int i = 0; i < (int)blobs.size(); i++)
      if (fabs(blobs[i][0] - (double)xpos) < 1.0 && fabs(blobs[i][1] - (double)ypos) < 1.0)
        foundBlob = true;
    if (foundBlob == false) return 1;
  }
  return 0;

}
