#include "TrackballTransControl.hh"

using namespace BIAS;
using namespace BIAS;

using namespace std;

TrackballTransControl::TrackballTransControl()
{
  TransNode_ = NULL;
}
    
TrackballTransControl::~TrackballTransControl()
{}
    
bool TrackballTransControl::RightMouseMoved(int x1, int x2, int y1, int y2)
{
  // Zoom out
  if (y1 - y2 > 0)
  {          
    MoveInViewingDirection(-Stepsize_);
  }
  // Zoom in
  else if(y1 - y2 < 0)
  {
    MoveInViewingDirection(Stepsize_);
  } 
  else
  {
    return false;
  }
  return true;
}

void TrackballTransControl::MoveInViewingDirection(double stepSize)
{
  Vector3<double> nodeC; 
  Vector3<double> direction; 
  Vector3<double> viewdir; 

  GetViewDirection(controlledObject_,viewdir);  
  GetMoveinViewDirection(controlledObject_ ,stepSize,viewdir, direction);  
  Translate_(direction);
}

void TrackballTransControl::Translate_(BIAS::Vector3<double>& v)
{
  if(TransNode_!=NULL)
  {
    TransNode_->AddTranslation(v);
  }
}

void TrackballTransControl::Rotate_(BIAS::Vector3<double>& axis,
                                    double rotationagle)
{  
 // BIASASSERT(TransNode_);

  if(TransNode_!=NULL)
  {
    TransNode_->Rotate(axis,rotationagle);
  }
}

bool TrackballTransControl::LeftMouseMoved(int x1, int x2, int y1, int y2)
{

  BIAS::Vector3<double> axis;
  double angleRAD;
  if(!GetRotationAxisAndAngle(controlledObject_,
                          x1, x2, y1, y2,
                          axis,angleRAD))
  {
    return(false);
  }  
  Rotate(axis, angleRAD); 
  return true;
}

// rotateaorundpot in trabckballcontrol
void TrackballTransControl::Rotate(BIAS::Vector3<double> axis, double angleRAD)
{
  Rotate_(axis,angleRAD);
}
    
//would be set point of interest... but poi is not needed here...
//so use it for scaling...
bool TrackballTransControl::LeftMouseDoubleClicked(int x, int y)
{
  //TODO scaling...
  return(false);
}

bool TrackballTransControl::
                   LeftAndRightMouseMoved(int x1, int x2, int y1, int y2)
{
  Vector3<double> viewdir;
  GetViewDirection(controlledObject_,viewdir);
  double rotationAngleRAD = 
  GetRotationAngle(controlledObject_,x1, x2, y1, y2, viewdir);
  RotateAroundViewingDirection(rotationAngleRAD);
  return(false);
}
    
bool TrackballTransControl::MouseWheelUsed(double stepsize)
{
  MoveInViewingDirection(stepsize);
  return (true);
}

bool TrackballTransControl::MiddleMouseMoved(int x1, int x2, int y1, int y2)
{
  Vector3<double> direction(0,0,0), up(0,1,0), C,viewdir;
  controlledObject_->GetExtrinsics(C, up);
  GetViewDirection(controlledObject_,viewdir);
  GetTranslation(controlledObject_,x1, x2, y1, y2,viewdir,direction);
  direction *=-1.0;
  Translate_(direction);
  return(true);
}

void TrackballTransControl::
     RotateAroundViewingDirection(double rotationAngleRAD)
{
  Vector3<double> viewdir;
  GetViewDirection(controlledObject_,viewdir);
  Rotate(viewdir, rotationAngleRAD);
}


    



