#ifndef __TransformNode_HH__
#define __TransformNode_HH__

#include <bias_config.h>

#ifndef BIAS_HAVE_OPENGL
#  error You need OpenGL. Please recompile BIAS with USE_OpenGL on.
#endif
#include <Base/Math/Vector3.hh>

namespace BIAS
{

  /** @class TransformNode
      @author grauel
      @ingroup g_glviewer
      @brief interface for transformations edited by a TrackballTransController
  */  
  class BIASGLviewer_EXPORT TransformNode
  {
      
   public:

    TransformNode(){};
    virtual ~TransformNode(){};

    /// this methods will be called by the TrackballTransControl 
    virtual bool AddTranslation(const BIAS::Vector3<double>& transl){ return false; };
    virtual bool SetTranslation(const BIAS::Vector3<double>& transl){ return false; };
    virtual bool GetTranslation(BIAS::Vector3<double>& transl){ return false; };

    virtual bool Rotate(const BIAS::Vector3<double>& axis,
                        double rotationAngleRAD){ return false; };
    virtual bool Scale(const BIAS::Vector3<double>& scale){ return false; };

  }; // end class

} // end of namespace

#endif
