#include <GLviewer/OutputAttachments/OutputHaze.hh>

using namespace std;
using namespace BIAS;

OutputHaze::OutputHaze(BIAS::glfRenderTarget *out) 
: GLProjectionOutputAttachment(out)
{
  InitShader_();
}

OutputHaze::~OutputHaze() {
  
}

int OutputHaze::
InitShader_() {
  string vertexCode =
      "void main()\r\n"
      "{\r\n"
      "  gl_TexCoord[0] = gl_MultiTexCoord0;\r\n"
      "  gl_Position = ftransform();\r\n"
      "}\r\n";
  string fragmentCode =
      "uniform sampler2D tex;\r\n"
      "uniform sampler2D dep;\r\n"
      "uniform float w;\r\n"
      "uniform float h;\r\n"
      "void main()\r\n"
      "{\r\n"
      "  vec4 color;\r\n"
      "  vec2 pos = gl_TexCoord[0].st;\r\n"
      "  color = texture2D(tex,pos);\r\n"
      "  float blue = color[2];\r\n"
      // scale other
      "  color = color * (vec4(1.0)-texture2D(dep, pos));\r\n"
      "  color[0] += 0.0;\r\n"
      "  color[1] += 0.075;\r\n"
      "  color[2] = blue+0.1;\r\n"
      "  color[3] = 1.0;\r\n"
      "  gl_FragColor = color;\r\n"
      "  gl_FragDepth =texture2D(dep, pos).r;\r\n"
      "}\r\n";

  return GLProjectionOutputAttachment::InitShader(vertexCode, fragmentCode);
}
