#ifndef OUTPUT_HAZE_HH_
#define OUTPUT_HAZE_HH_

#include <bias_config.h>

#ifndef BIAS_HAVE_OPENGL
#  error You need BIAS with USE_OpenGL Please recompile BIAS.
#endif // BUILD_GLviewer

#include <Gui/biasgl.h>
#include <Base/Debug/Debug.hh>

#include <OpenGLFramework/Base/glfRenderTarget.hh>
#include <GLviewer/OutputAttachments/GLProjectionOutputAttachment.hh>

namespace BIAS {

  /**
   * @brief exemplary output attachment, creating a bluish haze effect on the rendered output
   * @ingroup g_glviewer
   * @author fkellner
   */
  class BIASGLviewer_EXPORT OutputHaze : public GLProjectionOutputAttachment {
    public:
      // standards
      OutputHaze(BIAS::glfRenderTarget *out);
      virtual ~OutputHaze();
    protected:
      /// creates strings with shader code and calls InitShader(vertex, fragment) from superclass 
      int InitShader_();
      
  };

}
#endif
    
