#ifndef OUTPUT_LENS_DISTORTION_HH_
#define OUTPUT_LENS_DISTORTION_HH_

#include <bias_config.h>

#ifndef BIAS_HAVE_OPENGL
#  error You need BIAS with USE_OpenGL Please recompile BIAS.
#endif // BUILD_GLviewer

#include <Gui/biasgl.h>
#include <Base/Debug/Debug.hh>

#include <OpenGLFramework/Base/glfRenderTarget.hh>
#include <GLviewer/OutputAttachments/GLProjectionOutputAttachment.hh>
#include <OpenGLFramework/Base/glfTexture2D.hh>
#include <Geometry/ProjectionParametersPerspective.hh>

namespace BIAS {

  /**
   * @brief Distortion Rendering
   * @ingroup g_glviewer
   * @author fkellner, jkollmann
   */
  class BIASGLviewer_EXPORT OutputLensDistortion : public GLProjectionOutputAttachment {
    public:
      // standards
      OutputLensDistortion(BIAS::glfRenderTarget *out);
      void CreateLookupTable(BIAS::ProjectionParametersBase *pp);
      virtual ~OutputLensDistortion();
    protected:
      /// creates strings with shader code and calls InitShader(vertex, fragment) from superclass 
      int InitShader_();
      /** @brief main draw function
       * @return -1 if target is NULL, 0 on success*/
      int Draw_();

    private:
      BIAS::glfTexture2D distortionMap_;
  };

}
#endif
    
