#include <Base/Math/Vector2.hh>
#include "SceneCheckerboard2D.hh"


using namespace std;
using namespace BIAS;

SceneCheckerBoard2D::SceneCheckerBoard2D(){
  useAA_ = false;
}

void SceneCheckerBoard2D::Draw(){
  if (corners_.size() == 0) return;

  int sizeX = corners_.size();
  int sizeY = corners_[0].size();

  glDisable(GL_DEPTH_TEST);

  if (useAA_){
    glHint( GL_POLYGON_SMOOTH_HINT,GL_NICEST );
    glEnable(GL_POLYGON_SMOOTH);
    glEnable(GL_BLEND) ;
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  }

  glDisable(GL_LIGHTING);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity ();
  glOrtho (0, sizeX_, sizeY_, 0, 0, 1);
  glMatrixMode (GL_MODELVIEW);
  glPushMatrix();
  glLoadIdentity();
  glBegin(GL_QUADS);

 /* if (useAA_){
  for (int x = 0; x < sizeX-1; x++)
    for (int y = 0; y < sizeY-1; y++){
      if ((x+y) %2 == 0) glColor3f(0.0,0.0,0.0);
      else glColor3f(1.0,1.0,1.0);
      glVertex2f(corners_[x][y][0],corners_[x][y][1]);
      glVertex2f(corners_[x+1][y][0],corners_[x+1][y][1]);
      glVertex2f(corners_[x+1][y+1][0],corners_[x+1][y+1][1]);
      glVertex2f(corners_[x][y+1][0],corners_[x][y+1][1]);
      glVertex2f(corners_[x][y+1][0],corners_[x][y+1][1]);
      glVertex2f(corners_[x][y][0],corners_[x][y][1]);
      glVertex2f(corners_[x+1][y][0],corners_[x+1][y][1]);
      glVertex2f(corners_[x+1][y+1][0],corners_[x+1][y+1][1]);
    }
  glEnd();
  } else {*/
    for (int x = 0; x < sizeX-1; x++)
      for (int y = 0; y < sizeY-1; y++){
        if ((x+y) %2 == 0) glColor3f(0.0,0.0,0.0);
        else glColor3f(1.0,1.0,1.0);
        glVertex2f(corners_[x][y][0],corners_[x][y][1]);
        glVertex2f(corners_[x+1][y][0],corners_[x+1][y][1]);
        glVertex2f(corners_[x+1][y+1][0],corners_[x+1][y+1][1]);
        glVertex2f(corners_[x][y+1][0],corners_[x][y+1][1]);
       }
    glEnd();

  //}

  glPopMatrix();
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();

  glEnable(GL_DEPTH_TEST);
}

void SceneCheckerBoard2D::SetCorners(std::vector< std::vector < BIAS::Vector2< float > > > &corners){
  corners_ = corners;
}

void SceneCheckerBoard2D::SetImageSize(int sizeX, int sizeY){
  sizeX_ = sizeX;
  sizeY_ = sizeY;
}

void SceneCheckerBoard2D::SetColorBlack(const Vector3<unsigned char> &col){
  colorBlack_ = col;
}

void SceneCheckerBoard2D::SetColorWhite(const Vector3<unsigned char> &col){
  colorWhite_ = col;
}


