#ifndef SCENECHECKERBOARD_HH
#define SCENECHECKERBOARD_HH

#include <GLviewer/Scenes/SceneBase.hh>


namespace BIAS{
/**
 * @brief The SceneCheckerBoard class allows to draw a 3D checkerboard
 */
class SceneCheckerBoard2D : public BIAS::SceneBase {

public:
  SceneCheckerBoard2D();
  virtual void Draw();
  void SetImageSize(int sizeX, int sizeY);

  /// Set the checkerboard corners as 2D image coordinates
  void SetCorners(std::vector< std::vector < BIAS::Vector2< float > > > &corners);

  void SetColorBlack(const Vector3<unsigned char> &col);
  void SetColorWhite(const Vector3<unsigned char> &col);
  //void SetAntiAliasing(bool on);

protected:
  std::vector< std::vector < Vector2< float > > > corners_;

  Vector3<unsigned char> colorBlack_;
  Vector3<unsigned char> colorWhite_;

  int sizeX_;
  int sizeY_;
  bool useAA_;

};

}

#endif // SCENECHECKERBOARD_HH
