/* This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003-2009    (see file CONTACT for details)
   Vision N GmbH
   Schauenburgerstr. 116
   24118 Kiel
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

/**
   @example ExampleCleanString.cpp
   @brief Example for usage of wx clean string
   @ingroup g_examples
   @author MIP
*/

#include <Gui/StringConv.hh>

#include <Base/Common/BIASpragmaStart.hh>
#include <wx/wx.h>
#include <Base/Common/BIASpragmaEnd.hh>

using namespace BIAS;
using namespace std;

/** \cond HIDDEN_SYMBOLS*/
class MyApp : public wxApp
{
  virtual bool OnInit()
  {
    wxInitAllImageHandlers();
    wxString in = wxGetTextFromUser(wxT("Enter some text"));
    wxString out = CleanString(in);
    wxString message = wxT("Input: \n ") + in + wxT("\n\nOutput: \n ") + out;
    wxMessageBox(message);

    exit(0);
    return true;
  }
};
/** \endcond */
IMPLEMENT_APP(MyApp)

