/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
   @example ParamGUISample2.cpp
   @relates ParamGUI
   @brief Example for using the parameter gui classes
   @ingroup g_examples
   @author MIP
*/
#include <Base/Common/W32Compat.hh>

#include <wx/wx.h>

#include <Gui/ParamGUI.hh>
#include <Gui/StringConv.hh>
#include <Utils/Param.hh>
#include <iostream>

using namespace BIAS;
using namespace std;

// classes
/** \cond HIDDEN_SYMBOLS */
class MyApp : public wxApp 
{
 public:
    virtual bool OnInit();
};

DECLARE_APP(MyApp)

// implementation

IMPLEMENT_APP(MyApp) 

bool MyApp::OnInit() 
{ 
  ParamGUI param_;
  param_.AddParamInt("SampleInt1","Hilfetext zu SampleInt1",0,-100,100,0,1);
  param_.AddParamInt("SampleInt2","Hilfetext zu SampleInt2");
  param_.AddParamBool("SampleBool1","Hilfetext zu SampleBool1",false,0,1);
  param_.AddParamBool("SampleBool2","Hilfetext zu SampleBool2");
  param_.AddParamDouble("SampleDouble1","Hilfetext zu SampleDouble1");
  param_.AddParamString("SampleString1","Hilfetext zu SampleString1");

  param_.ParseCommandLine(wxTheApp->argc,WxToAsciiArray(wxTheApp->argv,wxTheApp->argc));

  wxFrame *frame = param_.GetFrame(NULL);
  frame->Show(TRUE); 
  SetTopWindow(frame);
  return true;
}
/** \endcond */
