#ifndef __FITCIRCLEFRAME_HH_
#define __FITCIRCLEFRAME_HH_

#include <Base/Common/W32Compat.hh>

#ifdef WIN32
#  include <Base/Common/getopt_W32.h>
#endif

#include <Gui/ImageCanvas.hh>
#include <Gui/StringConv.hh>
#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh>
#include <Base/ImageUtils/ImageDraw.hh>
#include <Base/Image/ImageConvert.hh>
#include <Filter/Rescale.hh>
#include <iostream>
#include <Base/Image/ImageIO.hh>
#include <Base/Debug/TimeMeasure.hh>
#include <wx/wx.h>
#include <wx/spinctrl.h>


enum wxIDs {id_quit = 42,  id_left,id_right, id_up, id_down, id_shrink,
            id_expand,id_dump,id_threshold,id_maxangle, id_sizeslider,
            id_xslider, id_yslider, id_rescale};


namespace BIAS{
 
  class BIASGui_EXPORT FitCircleFrame : public wxDialog{
     
  public:
    FitCircleFrame(const wxString& title, const wxPoint& pos, const wxSize& size,
                   const Image<unsigned char> &img);
    
    void SetXYRA(float newx,float newy,float newr,float angle);
    void ListenToChange(float *x,float *y,float *r,float *maxangle);

    void OnQuit(wxCommandEvent& WXUNUSED(event));
    void OnDump(wxCommandEvent& );
    void OnModifyCircle(wxCommandEvent& event);
    void OnKey(wxKeyEvent &event);
    void OnThreshold(wxSpinEvent & event);
    void OnMaxAngle(wxSpinEvent & event);
    void UpdateImage();
    void OnSlider(wxScrollEvent& event);
    void OnRescaleImage(wxSpinEvent& event);
  protected:
    BIAS::Rescale<unsigned char, unsigned char> rescaler_;
    Image <unsigned char> OrigImg_, WorkImg_, DrawImg_;
    ImageCanvas  *IC_;
    wxStatusBar *StatusBar_;
    wxSpinCtrl *spinCtrlAngle,*spinCtrlRescale;
    wxSlider *sizeSlider,*xSlider,*ySlider;
    float x,y,r,maxangle,*xp,*yp,*rp,*maxanglep;
    float inkr;
    unsigned char thecolor[3];
    unsigned char Threshold_;
    double fRescaleImageFactor_;
    DECLARE_EVENT_TABLE()

  };
}

#endif // _H_
