#ifndef __PlainImageCanvas_hh__
#define __PlainImageCanvas_hh__

#include <bias_config.h>
#include "ImageCanvas.hh"

namespace BIAS {

  /** @class PlainImageCanvas
      @ingroup g_gui
      @brief Image canvas that does not show zoom frames and redirects
             mouse click events to its parent.
      @author koeser */
  
  class BIASGui_EXPORT PlainImageCanvas : public BIAS::ImageCanvas
  {
  public:

    PlainImageCanvas(wxWindow* parent, wxStatusBar* sbar = NULL, int sbarid = 0);
    virtual ~PlainImageCanvas(){}

  protected:

    void OnLeftDClick(wxMouseEvent& event);
    void OnLeftDown(wxMouseEvent& event);
    void OnRightDown(wxMouseEvent& event);
    void OnMotion(wxMouseEvent& event);
    void OnChar(wxKeyEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnRightMouseButton(wxMouseEvent &event);
    void OnLeftMouseButton(wxMouseEvent &event);

    DECLARE_EVENT_TABLE()
  };

}

#endif // __PlainImageCanvas_hh__
