#ifdef WIN32
#  pragma warning (disable: 4005) // for VS8 + WX
#endif

#include "SimpleGLApp.hh"
#include "SimpleGLFrame.hh"
#include <Gui/ConsoleRedirectIO.hh>	// BIAS

using namespace std;
using namespace BIAS;

// required for wx RTTI dynamic construction: 
//IMPLEMENT_APP(SimpleGLApp);



BIAS::SimpleGLApp::SimpleGLApp()
:wxGLApp()
,frame(NULL)
,scene(NULL)
{}


// dummy implementation
void BIAS::SimpleGLApp::SetScene(){
  BIASASSERT(this->frame!=NULL);
  BIASASSERT(this->frame->pCanvas!=NULL);

  this->frame->pCanvas->pScene = this->scene;
}

void BIAS::SimpleGLApp::SetCanvas(BIAS::OpenGLCanvas * arg_pc){
  BIASASSERT(this->frame!=NULL);
  BIASASSERT(this->frame->pCanvas!=NULL);
  this->scene->pc = arg_pc;
}

// main entry routine 
bool BIAS::SimpleGLApp::OnInit()
{
  ConsoleRedirectIO();	//< utility: create a Redirection console for cout, cerr etc.
  cout << "Hello cout" << endl;	//< testing output: 
  cout << "Hello cerr" << endl;

  this->frame =
    new SimpleGLFrame( _T("SimpleGLApp frame"), wxPoint(0, 0),
    wxSize(640, 480));

  SetScene();
  BIASASSERT(this->frame->pCanvas!=NULL);
  SetCanvas(this->frame->pCanvas);

  frame->Show(TRUE);
  SetTopWindow(frame);
  return TRUE;
}
