#ifndef SimpleGLApp_hh_51120937298_
#define SimpleGLApp_hh_51120937298_

#include <Gui/OpenGLCanvas.hh>
#include <Utils/DrawTextGL.hh>
#include "SimpleGLFrame.hh"
#include "SceneGL.hh"

namespace BIAS {

  /** @brief Simple GL application 

  The idea of this class is taht you want an application around your (existing) display function. 
  Use SceneGL to wrap your GL calls function and plug it into *scene of constructor.
  @author Jan Woetzel
  */
  class BIASSimpleGLApp_EXPORT SimpleGLApp:public /*wxApp */ wxGLApp {
  public:
    SimpleGLApp();

    /// main equivalent
    virtual bool OnInit(); 

    virtual void SetScene();
    virtual void SetCanvas(BIAS::OpenGLCanvas * arg_pc);

    SimpleGLFrame *frame;
    BIAS::SceneGL *scene; //< plug your scene into thsi pointer, typically inside constructor
  };
} // namespace
#endif
