#ifndef _SimpleGLFrame_hh_55183029_
#define _SimpleGLFrame_hh_55183029_


#include <Gui/OpenGLCanvas.hh>
#include <Utils/DrawTextGL.hh>
#include "SimpleGLCanvas.hh"

enum Simple_IDs {
  ID_ABOUT = wxID_ABOUT
  ,ID_QUIT
  ,ID_MODE_PLUS
  ,ID_MODE_MINUS
  ,ID_LABEL_PLUS
  ,ID_LABEL_MINUS
  ,ID_FLAG_PLUS
  ,ID_FLAG_MINUS
};


namespace BIAS {

  /** @class SimpleGLFrame
      @brief Helper frame for SimplaGLApp
      @author Jan Woetzel */
  class BIASSimpleGLApp_EXPORT SimpleGLFrame : public wxFrame {
  public:
    SimpleGLFrame(const wxString & title, const wxPoint & pos,
      const wxSize & size);
    void OnQuit (wxCommandEvent & event);
    void OnAbout(wxCommandEvent & event);

    void OnInteraction(wxCommandEvent & event);


    SimpleGLCanvas *pCanvas;

    /// (global) params for simple user interaction with client Display routine
    static int mode;
    static int label;
    static int flag;

    DECLARE_EVENT_TABLE()
  };
} // namespace
#endif
