#ifndef __VideoSource_Controller_Base_HH__
#define __VideoSource_Controller_Base_HH__


#include <bias_config.h>
#ifndef BIAS_HAVE_WXWIDGETS
#  error You need BIAS_HAVE_WXWIDGETS. Recompile BIAS with USE_WXWIDGETS.
#endif
#include <wx/wx.h>

#include <bias_config.h>
#include <Base/Common/BIASpragmaStart.hh>
#include <VideoSource/VideoSource_Base.hh>
#include <Base/Common/W32Compat.hh>

namespace BIAS {

  class BIASGui_EXPORT VideoSource_Controller_Base : public wxFrame
  {

  public:

    VideoSource_Controller_Base(wxWindow *parent,
        wxWindowID id,
        const wxString& title,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = wxDEFAULT_FRAME_STYLE,
        const wxString& name = wxFrameNameStr);
  
    virtual ~VideoSource_Controller_Base();

//    virtual bool Show(bool show=true) = 0;

    virtual void SetVideoSource(BIAS::VideoSource *cam) { };
    virtual void SetShutterRange(unsigned int min,unsigned int max) { }
    virtual void SetGainRange(unsigned int min,unsigned int max) { }

    virtual void SetBrightnessRange(unsigned int min,unsigned int max) { }
    virtual void SetContrastRange(unsigned int min,unsigned int max) { }
    virtual void Update() { }

    // pmd funcs
    virtual void SetAmplitudeThresholdRange(unsigned int min,unsigned int max) {}
    virtual void SetSaturationThresholdRange(unsigned int min,unsigned int max) {}
    virtual void SetModulationRange(unsigned int min,unsigned int max) {}
    virtual void SetDistanceOffsetRange(unsigned int min,unsigned int max) {}
    virtual void SetIntegrationTimeRange(unsigned int min,unsigned int max) {}

    // selector
    virtual int GetSelectedImage() { return 0; }
    
  }; // end class

} // end namespace BIAS
#include <Base/Common/BIASpragmaEnd.hh>
#endif // __VideoSource_Controller_Base_HH__
