#ifndef __VideoSource_Controller_KINECT_HH__
#define __VideoSource_Controller_KINECT_HH__

#include <bias_config.h>
#include <Gui/VideoSource_Controller_Base.hh>

#include <VideoSource/VideoSource_Kinect_Base.hh>

#include <wx/grid.h>

namespace BIAS {
  
class BIASGui_EXPORT VideoSource_Controller_Kinect : public VideoSource_Controller_Base {
  public:

    VideoSource_Controller_Kinect(VideoSource *cam, wxWindow *parent, const std::string &title="VideoSourceConstroller Kinect");
    ~VideoSource_Controller_Kinect();

    void SetVideoSource(BIAS::VideoSource *cam);

  protected:
    wxRadioBox* m_radioBox1;
    wxGrid* m_grid1;
    wxButton* m_button1;
    wxButton* m_button5;
    wxButton* m_button6;
    wxButton* m_button2;
    wxButton* m_button3;
    wxButton* m_button4;
    wxTimer* timer_;
    
    virtual void OnSelectVideoMode( wxCommandEvent& event );
    virtual void OnUp( wxCommandEvent& event );
    virtual void OnLevel( wxCommandEvent& event );
    virtual void OnDown( wxCommandEvent& event );
    virtual void OnHide( wxCommandEvent& event );
    virtual void OnLoadCalib( wxCommandEvent& event );
    virtual void OnClose( wxCloseEvent& event );
    virtual void OnTimer( wxTimerEvent& event );
    virtual void OnToggleDepth( wxCommandEvent& event );

    BIAS::VideoSource_Kinect_Base *Cam_;
    int update_ms_;
  private:
    enum {
       ID_Timer
     };
    double curTilt_;
};
}
#endif // VideoSource_Controller_Kinect
