#ifndef __ZoomFrame_hh__
#define __ZoomFrame_hh__

#include <bias_config.h>

#ifndef BIAS_HAVE_WXWIDGETS
#  error BIAS_HAVE_WXWIDGETS not defined but required by ZoomFrame. Please enable BIAS_HAVE_WXWIDGETS in CMake configure step.
#endif
#include <Base/Common/BIASpragmaStart.hh>
#include <wx/wx.h>
#include <Base/Common/BIASpragmaEnd.hh>

namespace BIAS{

  // forward declarations
  class ZoomImageCanvas;
  class ImageBase;
  template <class T> class Image;

  /** @brief used by ImageCanvas and ScaledImageCanvas, should not be used
      directly
      @author woelk */
  class BIASGui_EXPORT ZoomFrame : public wxFrame
  {
    enum { MIA_ZoomQuitButton };
  public:
    ZoomFrame(wxWindow* parent, const wxString& title);
    ~ZoomFrame();

    void NewImage(BIAS::ImageBase& im, BIAS::Image<unsigned char>& ucim,
                  const wxString& name);
    void NewCoo(unsigned x, unsigned y);

    void SetZoom(unsigned z);

  protected:
    void Setup();

    void OnQuit(wxCommandEvent & event);
    void OnClose(wxCloseEvent & event);
    void OnZoomFactor(wxScrollEvent & event);
    //void OnKeyPress(wxKeyEvent &event);

    wxString ImageName_;
    wxString Title_;
    wxButton *QuitButton_;
    ZoomImageCanvas *Window_;
    wxSlider *SLScale_;

    DECLARE_EVENT_TABLE()
  }; // class ZoomFrame

} // namespace

#endif // __ZoomFrame_hh__
