/*
 * wxMatrixPanel.hh
 *
 *  Created on: Jun 25, 2010
 *      Author: ischiller
 */

#ifndef WXMATRIXPANEL_HH_
#define WXMATRIXPANEL_HH_

#include <bias_config.h>

#ifndef BIAS_HAVE_WXWIDGETS
#  error BIAS_HAVE_WXWIDGETS not defined but required by ProjectionGUI. Please enable BIAS_HAVE_WXWIDGETS in CMake configure step.
#endif

#include <wx/wx.h>
#include <vector>
#include <Base/Math/Matrix.hh>

namespace BIAS {

/** @brief Panel for displaying and editing matrices.
    @author jkollmann */
class BIASGui_EXPORT wxMatrixPanel : public wxPanel
{
public:
  wxMatrixPanel(wxWindow* parent, wxWindowID id, bool editable);
  void SetMatrix(const Matrix<double>& matrix);
  Matrix<double> GetMatrix();

private:
  bool editable_;
  int rows_, cols_;
  std::vector<wxTextCtrl*> controls_;
};


}

#endif /* WXMATRIXPANEL_HH_ */
