/* This file is part of the BIAS library (Basic ImageAlgorithmS).
   
   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "wxMessageDialogCheckbox.hh"
#include <iostream>

using namespace BIAS;


wxMessageDialogCheckbox::
wxMessageDialogCheckbox( wxWindow* parent, 
                         const wxString& title, 
                         const wxString& text, 
                         const wxPoint& pos, 
                         const wxSize& size, 
                         long style ):
  wxDialog( parent, 0, title, pos, size, style | wxRESIZE_BORDER |wxDEFAULT_DIALOG_STYLE )
{
  m_button1 = m_button2 =NULL;
  m_parent = parent;
  int w = size.GetWidth();
  int h = size.GetHeight();
  int length = text.Length();
  h = (double)((length*180)/(double)(w-10))+70;
  wxSize newSize(w,h);
  wxSize buttonSize(80,30);
  wxSize checkboxSize(w,30);

  this->SetSizeHints( newSize, wxDefaultSize );
  this->SetSize(newSize); 
  
  wxBoxSizer* bSizer2;
  bSizer2 = new wxBoxSizer( wxVERTICAL );


  displayText_ = new wxStaticText(this,wxID_ANY,wxT("test"));
  displayText_->SetLabel(text);
  displayText_->Wrap(w-5);
  bSizer2->Add( displayText_, 0, wxALL, 5 );

  checkBox_ = new wxCheckBox(this, wxID_CHECKBOX,
                             wxT("Do not bother me again!"), 
                             wxDefaultPosition, checkboxSize, 0 );
  bSizer2->Add( checkBox_, 0, wxALL, 5 );
  //ok button
  if (style & wxOK){
	 m_button1 = new wxButton( this, wxID_OK);
	 if(style & wxCANCEL)
       m_button2 = new wxButton( this, wxID_CANCEL);		 
  }
  else if (style & wxYES_NO){
	  m_button1 = new wxButton( this, wxID_YES);
	  m_button2 = new wxButton( this, wxID_NO);
  }

  m_sdbSizer2 = new wxStdDialogButtonSizer();

  if(m_button1 != NULL)
    m_sdbSizer2->Add(m_button1, 0, wxALL, 5 );
  if(m_button2 != NULL)
    m_sdbSizer2->Add(m_button2, 0, wxALL, 5 ); 
  
  m_sdbSizer2->Realize();
  bSizer2->Add( m_sdbSizer2, 0, wxALL, 5 );
  this->SetSizer( bSizer2 );
  this->Layout();
  this->Fit();
}

wxMessageDialogCheckbox::
~wxMessageDialogCheckbox()
{
}

bool
wxMessageDialogCheckbox::
GetChecked(){
  return checkBox_->IsChecked();
}

