/* This file is part of the BIAS library (Basic ImageAlgorithmS).
   
   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __wxMessageDialogCheckbox__
#define __wxMessageDialogCheckbox__

#include <bias_config.h>
#include <Base/Common/W32Compat.hh>

#include <wx/string.h>
#include <wx/stattext.h>
#include <wx/gdicmn.h>
#include <wx/font.h>
#include <wx/colour.h>
#include <wx/settings.h>
#include <wx/checkbox.h>
#include <wx/sizer.h>
#include <wx/button.h>
#include <wx/dialog.h>

///////////////////////////////////////////////////////////////////////////

#define wxID_CHECKBOX 2319

///////////////////////////////////////////////////////////////////////////////
/// Class wxMessageDialogCheckbox
///////////////////////////////////////////////////////////////////////////////

namespace BIAS{

  class BIASGui_EXPORT wxMessageDialogCheckbox : public wxDialog 
  {
	private:
	
 
	protected:
	  wxStaticText* displayText_;
	  wxCheckBox* checkBox_;
	  wxStdDialogButtonSizer* m_sdbSizer2;
	  wxButton *m_button1,*m_button2;	
      wxWindow* parent;

	public:
		wxMessageDialogCheckbox( wxWindow* parent, 
                             const wxString& title = wxT("Ok dialog with check box"), 
                             const wxString& text = wxT("Your question?"), 
                             const wxPoint& pos = wxDefaultPosition, 
                             const wxSize& size = wxSize(200,120), 
                             long style = wxOK | wxDEFAULT_DIALOG_STYLE );
		~wxMessageDialogCheckbox();

    bool GetChecked();
  };
}
#endif //__wxMessageDialogCheckbox__
