/* This file is part of the BIAS library (Basic ImageAlgorithmS).
   
   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "wxProjectionDialog.hh"

namespace BIAS {

/*
 * \file wxProjectionDialog.cpp
 * \class wxProjectionDialog
 *  Created on: Jun 25, 2010
 *      Author: ischiller
 */
wxProjectionDialog::wxProjectionDialog(const Projection& projection, wxWindow* parent,
                                   wxWindowID id, const wxString& title,
                                   bool createButtons)
  : wxDialog(parent, id, title, wxDefaultPosition, wxSize(500, 550),
             wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER)
{
  projgui_ = new wxProjectionPanel(this, -1,
                  wxDefaultPosition,
                  wxDefaultSize,
                  wxTAB_TRAVERSAL,
                  wxT("panel"),
                  createButtons);

  projgui_->SetProjection(projection);

  wxSizer* buttonSizer = new wxBoxSizer(wxHORIZONTAL);
  buttonSizer->Add(new wxButton(this, wxID_OK,     wxT("OK")));
  buttonSizer->Add(new wxButton(this, wxID_CANCEL, wxT("Cancel")));

  wxSizer* mainSizer = new wxBoxSizer(wxVERTICAL);
  mainSizer->Add(projgui_, 1, wxEXPAND | wxALL, 5);
  mainSizer->Add(buttonSizer, 0, wxBOTTOM | wxALIGN_CENTER, 5);

  SetSizer(mainSizer);
}

const Projection& wxProjectionDialog::GetProjection() const
{
  return projgui_->GetProjection();
}


}
