/*
 * wxProjectionDialog.hh
 *
 *  Created on: Jun 25, 2010
 *      Author: ischiller
 */

#ifndef WXPROJECTIONDIALOG_HH_
#define WXPROJECTIONDIALOG_HH_
#include <bias_config.h>

#ifndef BIAS_HAVE_WXWIDGETS
#  error BIAS_HAVE_WXWIDGETS not defined but required by ProjectionGUI. Please enable BIAS_HAVE_WXWIDGETS in CMake configure step.
#endif

#include <wx/wx.h>
#include <Gui/wxProjectionPanel.hh>

namespace BIAS {

/** @brief Dialog containing a wxProjectionPanel.
     @author jkollmann */
  class BIASGui_EXPORT wxProjectionDialog : public wxDialog
  {
  public:
   wxProjectionDialog(const Projection& projection,
                    wxWindow* parent = NULL, wxWindowID id = -1,
                    const wxString& title = wxT("Projection"),
                    bool createButtons = true);
   const Projection& GetProjection() const;
  private:
   wxProjectionPanel* projgui_;
  };

}

#endif /* WXPROJECTIONDIALOG_HH_ */
