/* This file is part of the BIAS library (Basic ImageAlgorithmS).
   
   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel
   
   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.
   
   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/*
 * wxVectorPanel.hh
 *
 *  Created on: Jun 25, 2010
 *      Author: ischiller
 */

#ifndef WXVECTORPANEL_HH_
#define WXVECTORPANEL_HH_

#include <bias_config.h>
#include <vector>
#include <Base/Math/Vector.hh>

#ifndef BIAS_HAVE_WXWIDGETS
#  error BIAS_HAVE_WXWIDGETS not defined but required by ProjectionGUI. Please enable BIAS_HAVE_WXWIDGETS in CMake configure step.
#endif

#include <wx/wx.h>

namespace BIAS {

/** @brief Panel for displaying and editing vectors.
    @author jkollmann */
class BIASGui_EXPORT wxVectorPanel : public wxPanel
{
public:
  wxVectorPanel(wxWindow* parent, wxWindowID id, bool editable);
  void SetVector(const BIAS::Vector<double>& vector);
  BIAS::Vector<double> GetVector() const;

private:
  bool editable_;
  std::vector<wxTextCtrl*> controls_;
};

}

#endif /* WXVECTORPANEL_HH_ */
