#ifndef __wxVideoSettingsDialog__
#define __wxVideoSettingsDialog__

#include <bias_config.h>
#include <Base/Common/BIASpragmaStart.hh>
#include "wxVideoSettingsDialogBase.h"

/** \class wxVideoSettingsDialog
    \brief Implementing wxVideoSettingsDialogBase
    \author ischiller
    \date 11/06/2011
*/
class BIASGui_EXPORT wxVideoSettingsDialog : public wxVideoSettingsDialogBase
{
protected:
	// Handlers for wxVideoSettingsDialogBase events.
	void OnSelectFile( wxCommandEvent& event );
  void OnOk( wxCommandEvent& event );

  int SelectedCodecToFFMPEGCodecID_(int id);

  int mGoPSize_,mFps_,mBitrate_,mWidth_,mHeight_,mMaxBFrames_;
  wxString mFilename_;
  int mCodecID_;

public:
	/** Constructor */
	wxVideoSettingsDialog( wxWindow* parent );

  int GetGoPSize();
  int GetFPS();
  int GetBitrate();
  int GetWidth();
  int GetHeight();
  int GetMaxBFrames();
  wxString GetOutputFilename();
  /** \brief Returns the codec ID as in libavcodec/avcodec.h */
  int GetCodecID();

  void SetGoPSize(int value);
  void SetFPS(int value);
  void SetBitrate(int value);
  void SetWidth(int value);
  void SetHeight(int value);
  void SetMaxBFrames(int value);
  void SetOutputFilename(wxString value);

};
#include <Base/Common/BIASpragmaEnd.hh>
#endif // __wxVideoSettingsDialog__
