#ifndef __wxViscaControlPanel__
#define __wxViscaControlPanel__

/**
@file
Subclass of wxViscaControlPanelInterface, which is generated by wxFormBuilder.
*/
#include <bias_config.h>
#include <Base/Common/BIASpragmaStart.hh>
#include "wxViscaControlPanelInterface.h"
#include <PanTilt/ViscaControl.hh>

namespace BIAS
{
  /** Implementing wxViscaControlPanelInterface */
  class BIASGui_EXPORT wxViscaControlPanel : public BIAS::wxViscaControlPanelInterface
  {
  protected:
    // Handlers for wxViscaControlPanelInterface events.
    void OnScrollZoom( wxScrollEvent& event );
    void OnButtonWide( wxCommandEvent& event );
    void OnButtonTele( wxCommandEvent& event );
    void OnButtonStop( wxCommandEvent& event );
    void OnProgressive( wxCommandEvent& event );
    void OnButtonReset( wxCommandEvent& event );
    void OnOpenCam( wxCommandEvent& event );
    void OnCloseCam( wxCommandEvent& event );
    void OnScrollPan( wxScrollEvent& event );
    void OnScrollTilt( wxScrollEvent& event );
    void OnConnect( wxCommandEvent& event );
    void OnClose( wxCommandEvent& event );

    BIAS::ViscaControl viscaControl_;

  public:
    /** Constructor */
    wxViscaControlPanel( wxWindow* parent );
  };
}
#include <Base/Common/BIASpragmaEnd.hh>
#endif // __wxViscaControlPanel__
