#ifndef __wxViscaControlPanelButtons__
#define __wxViscaControlPanelButtons__

/**
@file
Subclass of wxViscaControlPanelButtonsInterface, which is generated by wxFormBuilder.
*/
#include <bias_config.h>
#include <Base/Common/BIASpragmaStart.hh>
#include "wxViscaControlPanelButtonsInterface.h"
#include <PanTilt/ViscaControl.hh>

namespace BIAS
{
  /** Implementing wxViscaControlPanelButtonsInterface */
  class BIASGui_EXPORT wxViscaControlPanelButtons : public wxViscaControlPanelButtonsInterface
  {

  public:
    /** Constructor */
    wxViscaControlPanelButtons( wxWindow* parent );

    bool SetColour(const wxColour &colour);

    BIAS::ViscaControl* GetControl() const {
      return (const_cast<BIAS::ViscaControl*>(&viscaControl_));
    }

  protected:
    // Handlers for wxViscaControlPanelButtonsInterface events.
    void OnScrollZoom( wxScrollEvent& event );
    void OnButtonWide( wxCommandEvent& event );
    void OnButtonTele( wxCommandEvent& event );
    void OnButtonStop( wxCommandEvent& event );
    void OnProgressive( wxCommandEvent& event );
    void OnButtonReset( wxCommandEvent& event );
    void OnOpenCam( wxCommandEvent& event );
    void OnCloseCam( wxCommandEvent& event );
    void OnUpLeft( wxCommandEvent& event );
    void OnUp( wxCommandEvent& event );
    void OnUpRight( wxCommandEvent& event );
    void OnLeft( wxCommandEvent& event );
    void OnRight( wxCommandEvent& event );
    void OnDownLeft( wxCommandEvent& event );
    void OnDown( wxCommandEvent& event );
    void OnDownRight( wxCommandEvent& event );
    void OnConnect( wxCommandEvent& event );
    void OnClose( wxCommandEvent& event );
    void OnStop( wxCommandEvent& event );
    void OnButtonHome( wxCommandEvent& event );

    BIAS::ViscaControl viscaControl_;

  };
}
#include <Base/Common/BIASpragmaEnd.hh>
#endif // __wxViscaControlPanelButtons__
