#ifndef WXCOMPAT_HH
#define WXCOMPAT_HH

/// This file defines a few stable wx commands for functions that have changed over
/// different wx version

#if wxCHECK_VERSION(2, 9, 0)
    #define WXCOMPAT_wxFD_SAVE  wxFD_SAVE
    #define WXCOMPAT_wxFD_OPEN  wxFD_OPEN
    #define WXCOMPAT_wxFD_MULTIPLE wxFD_MULTIPLE
    #define WXCOMPAT_wxFD_FILE_MUST_EXIST wxFD_FILE_MUST_EXIST
    #define WXCOMPAT_wxFD_OVERWRITE_PROMPT wxFD_OVERWRITE_PROMPT
    #define WXCOMPAT_wxBitmapToggleButton  wxBitmapToggleButton
    #define WXCOMPAT_ScW_OnPaint(event) HandleOnPaint(event)
    #define WXCOMPAT_DC_OK IsOk
#else
    #define WXCOMPAT_wxFD_SAVE  wxSAVE
    #define WXCOMPAT_wxFD_OPEN  wxOPEN
    #define WXCOMPAT_wxFD_MULTIPLE wxMULTIPLE
    #define WXCOMPAT_wxFD_FILE_MUST_EXIST wxFILE_MUST_EXIST
    #define WXCOMPAT_wxFD_OVERWRITE_PROMPT wxOVERWRITE_PROMPT
    #define WXCOMPAT_wxBitmapToggleButton  wxToggleBitmapButton
    #define WXCOMPAT_ScW_OnPaint(event) OnPaint(event)
    #define WXCOMPAT_DC_OK Ok
#endif

#endif // WXCOMPAT_HH
