/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __TrackerBaseHomography_hh__
#define __TrackerBaseHomography_hh__

#include <Matcher2D/TrackerBaseInterface.hh>
  
namespace BIAS {

  /** @class TrackerBaseHomography
      @ingroup g_tracker
      @brief  
      @author beder 11/2007 */
  template <class StorageType>
  class BIASMatcher2D_EXPORT TrackerBaseHomography
    : public TrackerBaseInterface<StorageType>
  {
  public:
    TrackerBaseHomography() {}

   protected: 
    /** @brief fill in computed residui from Track_ */
    virtual void EvaluateResult_(KLT_TYPE& mad,KLT_TYPE& msd, 
                                 Matrix<KLT_TYPE>& cov);


    virtual int Track_(Vector2<KLT_TYPE>& p1, Vector2<KLT_TYPE>& p2,
                       Vector2<KLT_TYPE>& result, KLT_TYPE& error, 
                       int &iter,
                       const Matrix2x2<KLT_TYPE>& AffinePred,
                       Matrix2x2<KLT_TYPE>& AffineResult);

    using TrackerBaseInterface<StorageType>::_WinSize;
    using TrackerBaseInterface<StorageType>::BilinearRegion1_;
    using TrackerBaseInterface<StorageType>::BilinearRegion2_;
    using TrackerBaseInterface<StorageType>::_MaxIterations;
    using TrackerBaseInterface<StorageType>::_gradim2x;
    using TrackerBaseInterface<StorageType>::_gradim2y;
    using TrackerBaseInterface<StorageType>::_bl1;
    using TrackerBaseInterface<StorageType>::_bl2;

  };
}

#endif // __TrackerBaseHomography_hh__
