/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/** @example ExampleWeightedLinearLeastSqures.cpp
    @relates Lapack, Matrix
    @ingroup g_examples    
    @brief  this is an example using the Lapack Weighted linear Least Squares algorithm
    @author woelk 07/2004 
*/

#include "MathAlgo/Lapack.hh"
#include "Base/Math/Matrix.hh"
#include "Base/Math/Vector.hh"

using namespace BIAS;
using namespace std;

//int main(int argc, char *argv[])
int main()
{
  int res;
  Matrix<double> A(3, 3), B(3, 3);
  Vector<double> b(3), x;

  A.SetIdentity();
  B.SetIdentity();
  b[0]=2.0; b[1]=3.0; b[2]=16.0;

  x = ::Lapack_WLLS_solve(A, b, B, res);

  return res;
}
