__constant sampler_t smp_UndistortImage = CLK_NORMALIZED_COORDS_FALSE |
CLK_ADDRESS_CLAMP_TO_EDGE |
CLK_FILTER_NEAREST;
__constant sampler_t smpf_UndistortImage = CLK_NORMALIZED_COORDS_TRUE |
CLK_ADDRESS_CLAMP_TO_EDGE |
CLK_FILTER_LINEAR;

__kernel void UndistortImage
(
__read_only image2d_t input, // 0
__read_only image2d_t lookup, // 1
__write_only image2d_t result, // 2
int toGrey, //3
float colorScale, // 4
int downsampleFaktorX, // 5
int downsampleFaktorY // 6
)
{
int2 xy;
xy.x = get_global_id( 0 ); // x index
xy.y = get_global_id( 1 ); // y index

int2 downsample_xy;
downsample_xy.x = xy.x * downsampleFaktorX;
downsample_xy.y = xy.y * downsampleFaktorY;

float4 coord = read_imagef(lookup, smp_UndistortImage, downsample_xy);
float2 coord_xy= (float2)(coord.x, coord.y);

int intype  = get_image_channel_data_type(input);
uint4 color;
if (intype == CLK_FLOAT) {
float4 tmpColor = read_imagef(input, smpf_UndistortImage, coord_xy);
if (toGrey==1)
{
color.x = min((uint)255,(uint)rint((0.299*tmpColor.x + 0.587*tmpColor.y + 0.114*tmpColor.z)*colorScale));
color.y = color.x;
color.z = color.x;
color.w = 0;
} else {
tmpColor = tmpColor*colorScale;
color.x = min((uint)255,(uint)rint(tmpColor.x));
color.y = min((uint)255,(uint)rint(tmpColor.y));
color.z = min((uint)255,(uint)rint(tmpColor.z));
color.w = 0;
}
} else {
color = read_imageui(input, smpf_UndistortImage, coord_xy);
if (toGrey==1)
{
color.x = min((uint)255,(uint)rint(0.299*color.x + 0.587*color.y + 0.114*color.z));
color.y = color.x;
color.z = color.x;
color.w = 0;
}
}

write_imageui(result, xy, color);
}

//===================================


