__constant sampler_t smp = CLK_NORMALIZED_COORDS_FALSE | CLK_ADDRESS_CLAMP_TO_EDGE | CLK_FILTER_NEAREST;

__kernel void adaptivethreshold(
	__read_only image2d_t src,
	__read_only image2d_t gaussian,
	__write_only image2d_t dst,
	float colorthreshold,
	float lowcolorthreshold)
{
   int ii = get_global_id(0);
   int jj = get_global_id(1);
   
   float mean = read_imagef(gaussian, smp, (int2)(ii, jj)).x;
   float color = read_imagef(src, smp, (int2)(ii, jj)).x;
   
   float result = 1.0f;
   if (color+colorthreshold<mean) result = 0.0f;
   if (mean<lowcolorthreshold) result = 0.0f;
   
   int2 coords = (int2)(XM*ii, jj);
   write_imagef(dst, coords, (float4)(result));
}
