/*
 * clfAlgorithm.hh
 *
 *  Created on: Nov 1, 2011
 *      Author: fkellner
 */

#ifndef CLFALGORITHM_HH_
#define CLFALGORITHM_HH_
#include <Base/Common/BIASpragmaStart.hh>
#include <bias_config.h>
#include <OpenCLFramework/clfContext.hh>
#include <OpenCLFramework/clfProgram.hh>

namespace BIAS {

class BIASOpenCLFramework_EXPORT clfAlgorithm {
public:
  clfAlgorithm();
  clfAlgorithm(clfContext *ctx, bool sharedGL = false, unsigned int device = 0);
  virtual ~clfAlgorithm();

  clfContext *GetContext(){return context_;}

  clfProgram* GetCLProgram(){return programCL_;}

  static void getlocsize(const unsigned int val, unsigned int &result);
  static unsigned int getlocsize(const unsigned int val);

protected:

  void InitInternal_(clfContext *ctx, bool sharedGL, unsigned int device);

  clfContext *context_;
  clfProgram *programCL_;
  bool ownContext_;
  bool isSharedGL_;
  int maxComputeUnits_;
  int device_;
};

} /* namespace BIAS */
#include <Base/Common/BIASpragmaEnd.hh>
#endif /* CLFALGORITHM_HH_ */
