__kernel void mean_filter(__read_only image2d_t srcimage, __write_only image2d_t destimage)
{

const sampler_t sampler =  CLK_NORMALIZED_COORDS_FALSE |
                           CLK_ADDRESS_CLAMP_TO_EDGE |
                           CLK_FILTER_NEAREST;
  int2 xy;
  xy.x = get_global_id( 0 ); // x index
  xy.y = get_global_id( 1 ); // y index

  int2 south, east;
  south.x = 0;
  south.y = 1;
  east.x = 1;
  east.y = 0;
  float factor = 1.0f/9.0f;
  float4 srcColor =
    read_imagef(srcimage, sampler, xy) * factor;
  srcColor += factor * (
    read_imagef(srcimage, sampler, xy+south) +
    read_imagef(srcimage, sampler, xy-south) +
    read_imagef(srcimage, sampler, xy+east) +
    read_imagef(srcimage, sampler, xy-east) );
  srcColor += factor * (
    read_imagef(srcimage, sampler, xy+south+east) +
    read_imagef(srcimage, sampler, xy-south-east) +
    read_imagef(srcimage, sampler, xy+south-east) +
    read_imagef(srcimage, sampler, xy-south+east) );
  // Clamp and write image
  xy.x = xy.x*XM;
  write_imagef(destimage, xy, clamp(srcColor, 0.0f, 255.0f));
}
