/* 
 This file is part of the BIAS library (Basic ImageAlgorithmS).

 Copyright (C) 2003, 2004    (see file CONTACTS for details)
 Multimediale Systeme der Informationsverarbeitung
 Institut fuer Informatik
 Christian-Albrechts-Universitaet Kiel


 BIAS is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 BIAS is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with BIAS; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef CLFFILTER_HH_
#define CLFFILTER_HH_

#include <Base/Common/BIASpragmaStart.hh>
#include <Base/Image/Image.hh>
#include <OpenCLFramework/clfOpenCL.hh>
#include <OpenCLFramework/clfContext.hh>

namespace BIAS {

  template <class InputStorageType, class OutputStorageType> 
  class BIASOpenCLFramework_EXPORT clfFilter {
    public:
      clfFilter(clfContext *ctx);
      virtual ~clfFilter();
      
      int Filter(clfImage2D *src, clfImage2D *dst);
      
      int Clear(float color, clfImage2D *image);
      
      virtual int Build(unsigned int size);

    protected:
      int FilterSep_(std::string nameX,std::string nameY,
                     clfImage2D *src, clfImage2D *dst);

      int Filter_(std::string name, clfImage2D *src,
                  clfImage2D *dst, int blockX=16, int blockY=16);

      int SetFilter_(unsigned int size, const float *mask);
      int SetFilter1D_(unsigned int size, const float *mask);
      clfContext *context_;
      clfImage2D *tmpImage_;
      clfBuffer *filterMask_;
      clfProgram *program_;
      std::string programName_;
      unsigned int winSize_;

    private:

  };

} /* namespace BIAS */
#include <Base/Common/BIASpragmaEnd.hh>
#endif /* CLFFILTER_HH_ */
