/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef CLFDEVICEINFO_HH_
#define CLFDEVICEINFO_HH_

#include <string>
#include <vector>

struct clfDeviceInfo {
    std::string name;            // Name of Device
    std::string extensions;      // The Extensions the Device Supports
    std::string clfver;       // The clf Version the Device Supports
    std::string driverVersion;
    int maxComputeUnits; // 
    unsigned long long globalMemSize;
    unsigned long long localMemSize;
    size_t maxWorkgroupSize;
    unsigned int maxWorkitemDimensions;
    std::vector<size_t> maxWorkitemSizes;
    bool imageSupport;  // is image supported
    size_t maxImg2DWidth;
    size_t maxImg2DHeight;
    unsigned int maxWriteImgs;
    unsigned int maxReadImgs;
    bool hasGLsharing;
    
};

#endif /* CLFDEVICEINFO_HH_ */
