/*
 * clfKernelSources.hh
 *
 *  Created on: Jun 1, 2012
 *      Author: fkellner
 */

#ifndef CLFKERNELSOURCES_HH_
#define CLFKERNELSOURCES_HH_

#include <OpenCLFramework/clfOpenCL.hh>
#include <map>
#include <string>

namespace BIAS {

class BIASOpenCLFramework_EXPORT clfKernelSources {
public:
  clfKernelSources();
  virtual ~clfKernelSources();

  inline void AddSource(const std::string fname, std::string &source, unsigned int &blocks) {
    clkernelmap_[fname] = source.c_str();
    clnumblocks_[fname] = blocks;
  }

  std::string GetSource(std::string fname);

  inline void AddSource(const std::string fname, const char *source, unsigned int &blocks) {
    clkernelmap_[fname] = source;
    clnumblocks_[fname] = blocks;
  }

private:
  std::map<std::string, const char *> clkernelmap_;
  std::map<std::string, unsigned int> clnumblocks_;
};

} /* namespace BIAS */
#endif /* CLFKERNELSOURCES_HH_ */
