/* 
 This file is part of the BIAS library (Basic ImageAlgorithmS).

 Copyright (C) 2003, 2004    (see file CONTACTS for details)
 Multimediale Systeme der Informationsverarbeitung
 Institut fuer Informatik
 Christian-Albrechts-Universitaet Kiel


 BIAS is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 BIAS is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with BIAS; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef CLFMEMORY_HH_
#define CLFMEMORY_HH_

#include <Base/Common/BIASpragmaStart.hh>
#include <OpenCLFramework/clfOpenCL.hh>

namespace BIAS {

  class BIASOpenCLFramework_EXPORT clfMemory {
    public:
      virtual ~clfMemory();
      
      inline bool Initialized() { return initialized_; }
      inline bool IsSharedGL() { return sharedGL_; }
      
      inline unsigned int Size() { return size_; }
      unsigned int GLId(); 

      void UnMap(void *data);

      bool IsReadOnly();
      bool IsWriteOnly();

    protected:
      clfMemory(cl::Context *context, cl::CommandQueue *queue);
      cl::Memory& memory();
      
      int DetermineMemFlags_(bool readonly, bool writeonly, const void *hostptr=NULL, bool copy=false);
      
      cl::Context* context_;
      cl::CommandQueue* queue_;
      cl::Memory buffer_;
      
      unsigned int size_;
      bool initialized_;
      bool sharedGL_;
      unsigned int glid_;
    private:
      friend class clfContext;
  };

}
#include <Base/Common/BIASpragmaEnd.hh>
#endif /* CLFMEMORY_HH_ */
