/*
 This file is part of the BIAS library (Basic ImageAlgorithmS).

 Copyright (C) 2003-2009    (see file CONTACT for details)
 Multimediale Systeme der Informationsverarbeitung
 Institut fuer Informatik
 Christian-Albrechts-Universitaet Kiel


 BIAS is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 BIAS is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with BIAS; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __glfScreen_hh__
#define __glfScreen_hh__

#include "glfCommon.hh"
#include "glfRenderTarget.hh"

namespace BIAS {

  /**
   * \brief Represents the default render target of the current OpenGL context,
   * i.e. a window or a pbuffer.
   * This class is a singleton and cannot be instantiated.
   * \ingroup g_openglframework
   * \author jkollmann
   */
  class BIASOpenGLFramework_EXPORT glfScreen : public glfRenderTarget {
  public:

    /**
     * Returns the global screen instance.
     */
    static glfScreen& GetInstance();

    // glfRenderTarget interface
    virtual void Bind() const;

  private:
    glfScreen() {}
  };
  
} // namespace BIAS

#endif // __glfScreen_hh__
