#ifndef __glfTexture3D_hh__
#define __glfTexture3D_hh__

#include "glfTexture.hh"

namespace BIAS {

    class BIASOpenGLFramework_EXPORT glfTexture3D : public glfTexture
    {
    public:
        glfTexture3D();

        /** Convenience wrapper **/
        void Set(GLenum minFilter = GL_NEAREST,
                 GLenum magFilter = GL_NEAREST,
                 GLenum wrapS = GL_CLAMP,
                 GLenum wrapT = GL_CLAMP,
                 GLint textureNr = GL_TEXTURE0);


        void Allocate3DImage(int width, int height, int depth,
                             GLenum internalFormat, int mipmap = 0);

        void Allocate3DImage(int width, int height, int depth,
                             ImageBase::EStorageType storageType,
                             ImageBase::EColorModel colorModel,
                             int mipmap = 0);

        void Upload2DImage(const BIAS::ImageBase& image, unsigned int level);

    private:
        /** An intuitive assignment operator should generate a copy, as long as nobody is willing to implement
     * the generation of a copy in gl controlled memory this operator cannot be used.
     */
        glfTexture3D& operator=(const glfTexture3D& b);

        /** An intuitive copy constructor should generate a copy, as long as nobody is willing to implement
     * the generation of a copy in gl controlled memory this constructor cannot be used.
     */
        glfTexture3D(const glfTexture3D& t);

    };

}

#endif // __glfTexture3D_hh__
