/*
 This file is part of the BIAS library (Basic ImageAlgorithmS).

 Copyright (C)  2008, 2009    (see file CONTACT for details)
 Multimediale Systeme der Informationsverarbeitung
 Institut fuer Informatik
 Christian-Albrechts-Universitaet Kiel


 BIAS is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 BIAS is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with BIAS; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "glfViewport.hh"

using namespace BIAS;

glfViewport::glfViewport()
{
  x_ = 0;
  y_ = 0;
  width_ = 100;
  height_ = 100;
}

glfViewport::glfViewport(int x, int y, int width, int height)
{
  x_ = x;
  y_ = y;
  width_ = width;
  height_ = height;
}

void glfViewport::SetOrigin(int x, int y)
{
  x_ = x;
  y_ = y;
}

void glfViewport::SetSize(int width, int height)
{
  width_ = width;
  height_ = height;
}

void glfViewport::Bind() const
{
  glViewport(x_, y_, width_, height_);
}
