/*
 This file is part of the BIAS library (Basic ImageAlgorithmS).

 Copyright (C)  2008, 2009    (see file CONTACTS for details)
 Multimediale Systeme der Informationsverarbeitung
 Institut fuer Informatik
 Christian-Albrechts-Universitaet Kiel


 BIAS is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 BIAS is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with BIAS; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __glfRenderingContext_GLX_hh__
#define __glfRenderingContext_GLX_hh__

#include "glfRenderingContext.hh"

#include <GL/glx.h>
#include <GL/glext.h>
#include <X11/Xlib.h>

namespace BIAS {

  /**
   * Base class for GLX rendering contexts.
   * \author 05/2007 jkollmann
   */
  class BIASOpenGLFramework_EXPORT glfRenderingContext_GLX : public glfRenderingContext {
  public:
    glfRenderingContext_GLX();
    ~glfRenderingContext_GLX();

    virtual void Init(const glfRenderingContextConfig& config);
    virtual void Destroy();
    virtual void MakeCurrent();
    virtual void DoneCurrent();
    virtual void GetConfig(glfRenderingContextConfig& config);

  protected:
    virtual GLXDrawable CreateDrawable(int width, int height, GLXFBConfig fbConfig) = 0;
    virtual void DestroyDrawable() = 0;
    virtual int GetDrawableType() const = 0;

    Display*    display_;
    GLXDrawable drawable_;
    GLXContext  context_;
  };
  
} // namespace BIAS

#endif // __glfRenderingContext_GLX_hh__

