/**
 * median filter using a bubble sort.
 * \author bartczak 10/2008
**/

uniform sampler2D img0;
uniform vec2 MIP_pixelOffset;

#define toVec(x) x.rgb

#define range 3
#define rangeHalf 1
#define rangeSqr 9
#define medianIndex 4
#define swap(a, b)				temp = a; a = min(a, b); b = max(temp, b);
#define swapI(a, b)				swap(v[a], v[b]);

void main() {

  vec3 v[rangeSqr];

  // Add the pixels which make up our window to the pixel array.
  for(int dX = -rangeHalf; dX <= rangeHalf; ++dX) {
    for(int dY = -rangeHalf; dY <= rangeHalf; ++dY) {		
      vec2 offset = vec2(float(dX), float(dY));
		  v[(dX + rangeHalf) * range + (dY + rangeHalf)] = toVec(texture2D(img0, gl_TexCoord[0].xy + offset * MIP_pixelOffset));
    }
  }
  
  vec3 temp;//needed by swap define

  //bubble sort
  for(int i=0; i<rangeSqr; i++) {
     for(int j=0; j<rangeSqr-1-i; j++) {
       swapI(j, j+1);
     } 
  }

  gl_FragColor.rgb = v[medianIndex];

}
