/*
 * WoWDisplayShader.hh
 *
 *  Created on: Feb 9, 2010
 *      Author: africk
 */

#ifndef __WOW_DISPLAY_SHADER_HH__
#define __WOW_DISPLAY_SHADER_HH__

#include <OpenGLFramework/Base/glfTexture2D.hh>
#include <OpenGLFramework/Base/glfBatch.hh>
#include <OpenGLFramework/Base/glfFramebufferObject.hh>
#include <OpenGLFramework/SpecializedBatches/PerPixelProcessingBase.hh>

#include <bias_config.h>

namespace BIAS {

class BIASOpenGLFramework_EXPORT WoWDisplayShader: public PerPixelProcessingBase {
public:
	WoWDisplayShader();
	virtual ~WoWDisplayShader();

	void SetDisparityImage(glfTexture2D* dispImage);
	void SetColorImage(glfTexture2D* colorImage);

        void Init(int mode = 0);

	void Draw();

	void FlipColorImage(bool flip) {
		if (flip) {
			flip_ = 1;
		} else {
			flip_ = 0;
		}
	}

	void SetScale(float scale) {
		scale_ = scale;
	}

        void UseOcclLayer(bool occlLayer) {
            if (occlLayer) {
                withOcclLayer_ = 1;
            } else {
                withOcclLayer_ = 0;
            }
        }

        void SetHeader(std::vector<int>& header) {
            header_ = header;
        }

private:

        int mode_;

        int flip_;

        int withOcclLayer_;

	float scale_;

	unsigned int width_, height_;

	int wowFactor_, wowOffset_;

	int fullheader_[256];
        int newFullHeader_[512];
        std::vector<int> header_;

	glfTexture2D* dispImageP_;
	glfTexture2D* colorImageP_;

        std::string fragmentShaderCode_;
        std::string fragmentShaderCode1_;

        void CreateHeader_(int* fullheader, int wowFactor, int wowOffset);
        void CreateHeader2_(int* header, int wowFactor, int wowOffset);
};
}

#endif /* __WOW_DISPLAY_SHADER_HH__ */
