/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/** @example ExampleIselLinearControl.cpp
    @relates IselLinearControl
    @ingroup g_examples    
    @brief  Example for using the Isle linear controller, moves right and left
    @author MIP
*/

#include <PanTilt/IselLinearControl.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{

  IselLinearControl control; 
  if (control.Init("/dev/ttyUSB0") != 0) {
    cout << "Initialising IGOR unit on USB port 0 failed!" << endl;
    return -1;
  }
  
  cout << "I am talking to IGOR!" << endl;
  
  if (control.Reset() == 0) {
    cout << "IGOR says everything is good." << endl;
  }
  control.SetSpeed(40000);
  if (control.MoveRight(1000) == 0) {
    cout << "IGOR says everything is good." << endl;
  }
  if (control.MoveLeft(1000) == 0) {
    cout << "IGOR says everything is good." << endl;
  }
  if (control.SetPosition(500000) == 0) {
    cout << "IGOR says everything is good." << endl;
  }
  control.Close();
  return 0;
}
