/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/** @example ExampleViscaControl.cpp
    @relates ViscaControl
    @ingroup g_examples
    @author ischiller
*/

#include <PanTilt/ViscaControl.hh>

// include biassleep
#ifdef WIN32
#include <windows.h>
#endif
#include <Base/Common/W32Compat.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{

  BIAS::ViscaControl panTiltControl;
  bool bRet = panTiltControl.InitPanTiltUnit("/dev/ttyUSB0");
  if (!bRet) {
    cout << "Initialising Visca PTU on USB port 0 failed!" << endl;
    return -1;
  }

  panTiltControl.MoveAbsolute(10,0);
  biassleep(1);
  panTiltControl.MoveAbsolute(0,10);
  biassleep(1);
  panTiltControl.MoveAbsolute(10,10);
  biassleep(1);
  panTiltControl.MoveHome();
  biassleep(1);
  panTiltControl.ClosePanTiltUnit();
  return 0;
}
