/*
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef PANTILTMANUALCONTROL_HH_
#define PANTILTMANUALCONTROL_HH_

#include "PanTiltControlInterface.hh"

namespace BIAS{

/** \class PanTiltManualControl, derived from PanTiltControlInterface
 * \brief Manual control of pan tilt unit using keyboard control with ncurses
 * \author fkellner
 * */
class BIASPanTilt_EXPORT PanTiltManualControl : public PanTiltControlInterface {
public:
	/** \brief contructor */
	PanTiltManualControl(std::string device, bool heavyDutyMode);
	/** \brief Start the control */
	void StartControl();
	/** \brief Stop the control */
	void StopControl() {}
	/** \brief Resume the control */
  void ResumeControl() {}
};

/**
 * \class PanTiltManualControlFactory
 * \brief Factory to create a PanTiltManualControl
 */
class BIASPanTilt_EXPORT PanTiltManualControlFactory : public PanTiltControlFactory {
public:
	PanTiltManualControl* Create(std::string device, bool heavyDutyMode) {
		return new PanTiltManualControl(device, heavyDutyMode);
	}
};
}
#endif /*PanTiltManualControl_HH_*/
