#include <iostream>
#include <bias_config.h>
#include <Base/Debug/TimeMeasurement.hh>
#include <Base/Math/Utils.hh>
#include <Base/Math/Matrix3x3.hh>
#include <Base/Image/ImageBase.hh>
#include <Base/Image/Image.hh>

using namespace std;
using namespace BIAS;

/**
   @file simple.cpp
   @brief simple test for linking against BIAS
   @ingroup g_tests
   @author jwoetzel
*/

int main(int argc, char** argv )
{ 
  if (argc>0)
    cout<<"started "<<argv[0]<<endl;

  BIAS::TimeMeasurement t;

  float x(0.2f), s(0), c(0);
  BIAS::sincos(x,s,c);
  cout<<"sincos: "<<s<<" "<<c<<endl;
  cout<<"lerp: "<<BIAS::lerp(10, 20, 0.3) <<endl;

  BIAS::Matrix3x3<double> m;

  BIAS::ImageBase imbase;
  BIAS::Image<unsigned char> imUc;

  cout<<"done."<<endl; 
  return 0;
}

