/*
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <Base/Common/W32Compat.hh>

#include "ShowCamWxApp.hh"
#include "ShowCamWxFrame.hh"

using namespace BIAS;
using namespace std;


bool ShowCamWxApp::OnInit()
{
  // Open console for windows
  ConsoleRedirectIO();

  // create main frame
  ShowCamWxFrame *mainFrame;
  mainFrame = new ShowCamWxFrame(AsciiToWx("BIAS ShowCamWx"), wxPoint(0,0),
                                 wxSize(1000,650));

  // read params from file
  mainFrame->InitParams(argc, WxToAsciiArray(argv, argc));

  // necessary for high resolution on small monitors (hackish...)
 // mainFrame->SetSizeHints(900,700,1800,1600);

  // initialize cameras and try to open them
  mainFrame->InitCameras();

  //check if Pan Tilt Unit is requested and open it
#ifdef BIAS_HAVE_PanTilt
  mainFrame->InitPanTiltUnit();
#endif

  mainFrame->CreateMenu();
  // create main windows
  mainFrame->Show(true);

  SetTopWindow(mainFrame);

  return true;
}

IMPLEMENT_APP(ShowCamWxApp)
