/*
   This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel


   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.

   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __BVWXAPP_HH
#define __BVWXAPP_HH

#include <Base/Common/W32Compat.hh>

#include <wx/wx.h>
#include <wx/filename.h>
#include <wx/arrstr.h>

#define FRAME_DEFAULT_SIZE  wxSize(850,600)

#undef WXWIN_COMPATIBILITY
#if !wxUSE_DRAG_AND_DROP
#  error The dndFileTarget class requires drag and drop support in the WX library. Please recompile wxWidgets. __FILE__: __LINE__
#endif


namespace BIAS {

/**
    @file
    @ingroup g_tools
    @brief   Tool for displaying images (WX version)
             executable: biasviewwx, see BVWXApp.hh BVWXApp.cpp BVWXMainFrame.hh BVWXMainFrame.cpp
    @author  MIP
*/
class BVWXApp : public wxApp
{
public:
  virtual bool OnInit();
};

} // namespace BIAS

#endif // __BVWXAPP_HH
