/*
   This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel


   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.

   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "BVWXDnDTarget.hh"


using namespace BIAS;

BVWXDnDTarget::BVWXDnDTarget() { }

BVWXDnDTarget::BVWXDnDTarget(BVWXMainFrame* frame)
{
  _Frame = frame;
}

BVWXDnDTarget::~BVWXDnDTarget() { }

bool BVWXDnDTarget::OnDropFiles(wxCoord /*x*/,
                                    wxCoord /*y*/,
                                    const wxArrayString& filenames)
{
  BIASASSERT( _Frame != NULL);
  wxArrayString sortedFilenames(filenames);
  // sort alphabetically because file seq is not preserved "as expected"
  // (at least on Windows XP Explorer)
  sortedFilenames.Sort();
  _Frame->LoadImages(sortedFilenames);
  _Frame->FitSizetIfTooSmall();
  _Frame->RefitClients();

  return true;
}
