/*
   This file is part of the BIAS library (Basic ImageAlgorithmS).

   Copyright (C) 2003-2009    (see file CONTACT for details)
   Multimediale Systeme der Informationsverarbeitung
   Institut fuer Informatik
   Christian-Albrechts-Universitaet Kiel


   BIAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or
   (at your option) any later version.

   BIAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with BIAS; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __BVWXDNDTARGET_HH
#define __BVWXDNDTARGET_HH

#include <Base/Common/W32Compat.hh>

#include <wx/wx.h>
#include <wx/dnd.h>
#include "BVWXMainFrame.hh"


namespace BIAS {

/**
 * \brief drag and drop files onto application.
					drag a file from MS explorer or kde file manager
					directly onto an application
					(instaed of using a load from filename function.)
 * \internal
 * \author Jan Woetzel
 * \date 03/2005 */
class BVWXDnDTarget : public wxFileDropTarget
{
public:
  BVWXDnDTarget();
  BVWXDnDTarget(BIAS::BVWXMainFrame* frame);
  ~BVWXDnDTarget();

  virtual bool OnDropFiles(wxCoord x,
                              wxCoord y,
                              const wxArrayString& filenames);

protected:
  BIAS::BVWXMainFrame* _Frame;
};

} // namespace

#endif // __BVWXDNDTARGET_HH
