/*
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/** @example ExampleDataPlot.cpp
 *  @relates DataPlot
    @ingroup g_examples
    @brief Example for plotting using DataPlot
    @author MIP */

#include <Utils/DataPlot.hh>
#include <Base/Image/ImageIO.hh>
using namespace BIAS;
using namespace std;

int main(int argc,char *argv[])
{
  Image<unsigned char> plotarea(640,480,3);
  DataPlot Plot(plotarea);
  Plot.SetBGColour(ColourRGB<unsigned char>(10,10,10));
  Plot.Clear();

  Plot.SetXRange(0,100);
  Plot.SetYRange(-50,50);
  Plot.SetAutoRange(false,false);
  Plot.SetDrawingStyle(DataPlot::Lines);
  Plot.SetThickness(3);
  Plot.SetPenColour(ColourRGB<unsigned char>(255,0,0));
  Plot.DrawXAxis();
  Plot.SetPenColour(ColourRGB<unsigned char>(0,255,0));
  Plot.DrawYAxis();
  Plot.SetPenColour(ColourRGB<unsigned char>(255,255,0));
  for ( int i=0;i<100;i++)
    Plot.Plot(float(i),float(i-50));



  ImageIO::Save("ExampleDataPlot.ppm",plotarea,ImageIO::FF_ppm);




Plot.Clear();

  Plot.SetAutoRange(true,true);
  Plot.SetDrawingStyle(DataPlot::Points);
  Plot.SetThickness(3);
  Plot.SetPenColour(ColourRGB<unsigned char>(255,255,0));
  vector<float> data;
  for ( int i=0;i<100;i++) data.push_back(float(50-i));
  Plot.Plot(data);

  Plot.SetPenColour(ColourRGB<unsigned char>(255,0,0));
  Plot.DrawXAxis();
  Plot.SetPenColour(ColourRGB<unsigned char>(0,255,0));
  Plot.DrawYAxis();

  ImageIO::Save("ExampleDataPlot2.ppm",plotarea,ImageIO::FF_ppm);



  return 0;
}
