/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/** @example ExampleShowFreeD.cpp
 *  @relates ThreeDOut
    @ingroup g_examples
    @brief Example for ThreeDOut object, writes a wrl with a PMatrix
    @author MIP */


#include "Utils/ThreeDOut.hh"
using namespace std;
using namespace BIAS;

int main(int argc, char* argv[])
{ 
  if (argc<2) {
    BIASERR("too few arguments.");
    return -1;
  }
  ifstream ifs(argv[1]);
  ThreeDOutParameters p;
  p.CameraStyle = PyramidSolid;
  ThreeDOut T(p);
  int i=0, j = 0;
  while (ifs.good()) {
    PMatrix P;
    if (P.BBCIn(ifs)!=0) break;
    cout<<".";
    if (i++ == 10) {
      RGBAuc color(255,255,255,0);
      if (j++==1) {
        color[1]=0;
        color[2]=0;
      }
      T.AddPMatrix(P,640,480, color,0.05);
      i=0;
    }
  }
  ifs.close();
  cout<<endl;
  T.VRMLOut("test.wrl");
  return 0;
}
