/*
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <bias_config.h>

#include "GlewInitWrapper.hh"
#ifdef BIAS_HAVE_GLEW
# include <Gui/biasgl.h>
#endif
using namespace BIAS;

GlewInitWrapper::GlewInitWrapper()
{
#ifdef BIAS_HAVE_GLEW
  IsInitialised_ = false;
#else
  IsInitialised_ = true;
#endif
}

int GlewInitWrapper::Init()
{
  int res=0;
#ifdef BIAS_HAVE_GLEW
  if (!IsInitialised_) {
    res = glewInit();
    if (res ==GLEW_OK) IsInitialised_ = true;
    else BIASERR("glewInit failed: "<<res);
  }
#endif
  return res;
}
