#include "SampleGrabberCallback.hh"
#include <iostream>
//#include <Base/Helper.hh>
#include <Base/Debug/Debug.hh>

using namespace BIAS;
using namespace std;

SampleGrabberCallback::
SampleGrabberCallback()
{
  TargetBuffer_ = NULL;
  Width_ = 640;
  Height_ = 480;
  CallbackFunction_ = NULL;
}


SampleGrabberCallback::
~SampleGrabberCallback()
{}


#ifdef BIAS_HAVE_DSHOW
STDMETHODIMP SampleGrabberCallback::
BufferCB(double SampleTime, BYTE *pBuffer, long BufferLen)
{
//ISampleGrabberCB::BufferCB gets a pointer to a copy of the data in the media sample.
  //unsigned char *pImageData = camera_.GetImageData();
  //BIASASSERT(BufferLen==camera_.GetSizeByte());
  //memcpy(pImageData,pBuffer,BufferLen);
 // return S_OK; //nix da !
  return E_NOTIMPL;
}


STDMETHODIMP SampleGrabberCallback::
SampleCB(double SampleTime, IMediaSample *pSample)
{
  //cout <<"SampleGrabberCallback::SampleCB("<<SampleTime<<")"<<endl;
  /*HRESULT res;  
  REFERENCE_TIME rs, re;
  res = pSample->GetTime(&rs, &re);
  if (res==S_OK){
    cout << "GetTime("<<rs<<", "<<re<<")\n";
  }
  LONGLONG ms, me;
  res = pSample->GetMediaTime(&ms, &me);
  if (res==S_OK){
    cout << "GetMediaTime("<<rs<<", "<<re<<")\n";
  }*/
  if(SampleTrigger_ || !TargetBuffer_){return S_OK;}

  unsigned char *TargetBuffer = TargetBuffer_;
  unsigned int TargetSize     = TargetSize_;

  BYTE *pSampleData;
  pSample->GetPointer(&pSampleData);
  unsigned bytesperline = Width_ * 3;
  BYTE *pSampleDataLine = pSampleData;
  BYTE *pFlipTarget     = TargetBuffer + (Height_-1)* bytesperline;
  unsigned bytewidth = Width_*3;
  //flip and swap rgb 
  for(unsigned y=0; y<Height_; y++)
  {
    for(unsigned x=0; x<bytewidth; x+=3)
    {
     *(pFlipTarget+x) = pSampleDataLine[x+2];
     *(pFlipTarget+x+1) = pSampleDataLine[x+1];
     *(pFlipTarget+x+2) = pSampleDataLine[x];
   }
   pSampleDataLine+=bytesperline;
   pFlipTarget -=bytesperline;
 }

  SampleTrigger_ = true;
  if (CallbackFunction_){
    (*CallbackFunction_)(SampleTime);
  }
  return S_OK;
}

/****************************************************************/

STDMETHODIMP SampleGrabberCallback::
QueryInterface(REFIID riid, void ** ppv) {

	if( riid == IID_ISampleGrabberCB || riid == IID_IUnknown ) {
        *ppv = (void *) static_cast<ISampleGrabberCB*> ( this );
        return NOERROR;
    }    
    return E_NOINTERFACE;
}

#endif

void SampleGrabberCallback::
SampleTriggerArm()
{
	SampleTrigger_ = false;
}


void SampleGrabberCallback::
SampleTriggerWait()
{
  while (!SampleTrigger_) {Sleep(200/1000);} /// TODO: Make it platform independent
}


bool SampleGrabberCallback::
SampleTriggered()
{
	return SampleTrigger_;
}


void SampleGrabberCallback::
SetTargetBuffer(unsigned char *t, unsigned int s, unsigned w, unsigned h)
{
  TargetBuffer_ = t;
  TargetSize_ = s;
  Width_ = w;
  Height_ = h;
}
