/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
   @file TestPMDCam.cpp
   @brief Test pmdtec sdk directly
   @relates FFMPEGVideo
   @ingroup g_tests
   @author MIP
*/

#include <iostream>
#include <pmdmsdk.h>

using namespace std;
int main( int argc, char *argv[])
{
  PMDHandle hnd;
  int res; 
  unsigned int width;
  res = pmdConnectFireWire(&hnd);
  if ( res!=PMD_OK) {
    cout << "Error pmdConnectFireWire" << endl;
    return 1;
  }
  res = pmdUpdate(hnd);
  if ( res!=PMD_OK) {
    cout << "Error pmdUpdate" << endl;
    return 1;
  }
  double *dat;
  res = pmdGetDistances(hnd, (void**)&dat);
  if ( res!=PMD_OK) {
    cout << "Error pmdGetDistances" << endl;
    return 1;
  }
  res = pmdGetWidth(hnd, &width);
  if ( res!=PMD_OK) {
    cout << "Error pmdGetWidth" << endl;
    return 1;
  }
  cout << " First pixel depth is " << dat[0] << endl;
  cout << " Sensor width is: " << width << endl;
  pmdDisconnect(hnd);
  return 0;
}

