/*
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003-2009    (see file CONTACT for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __BIASVIDEOSOURCE_DISK_BAYER_HH__
#define __BIASVIDEOSOURCE_DISK_BAYER_HH__

#include <VideoSource/VideoSource_Disk.hh>
#include "Base/Debug/TimeMeasure.hh"


namespace BIAS{
/**
    \class VideoSource_Disk
    \ingroup g_videosource
    \author evers
    \brief This class simulates a video device by loading images from disk.
*/
  class BIASVideoSource_EXPORT VideoSource_Disk_Bayer : public VideoSource_Disk{

  public:
    VideoSource_Disk_Bayer();
    virtual ~VideoSource_Disk_Bayer();

    virtual int OpenDevice(const std::vector<std::string> &FileNames);

    int SetColorMode(BIAS::ImageBase::EColorModel mode);

    virtual int GrabSingle(BIAS::Camera <unsigned char> &image);
    virtual int GrabSingle(BIAS::Camera <float> &image);
#ifdef BUILD_IMAGE_USHORT
    virtual int GrabSingle(BIAS::Camera <unsigned short int> &image);
#endif
    virtual int GrabSingle(BIAS::ImageBase &image);


  };


} // namespace MIP

#endif
